Package: martini
Type: Package
Title: GWAS Incorporating Networks
Version: 1.32.0
Authors@R: c(person("Hector", "Climente-Gonzalez", 
                    email = "hector.climente@a.riken.jp",
                    role = c("aut", "cre"),
                    comment = c(ORCID = "0000-0002-3030-7471")),
             person("Chloe-Agathe", "Azencott", 
                    role = "aut",
                    comment = c(ORCID = "0000-0003-1003-301X")))
Description: martini deals with the low power inherent to GWAS studies by using 
    prior knowledge represented as a network. SNPs are the vertices of the 
    network, and the edges represent biological relationships between them 
    (genomic adjacency, belonging to the same gene, physical interaction between
    protein products). The network is scanned using SConES, which looks for 
    groups of SNPs maximally associated with the phenotype, that form a close 
    subnetwork.
License: GPL-3
LazyData: TRUE
Imports: igraph (>= 1.0.1), Matrix, memoise (>= 2.0.0), methods (>=
        3.3.2), Rcpp (>= 0.12.8), snpStats (>= 1.20.0), stats, utils,
Suggests: biomaRt (>= 2.34.1), circlize (>= 0.4.11), STRINGdb (>=
        2.2.0), httr (>= 1.2.1), IRanges (>= 2.8.2), S4Vectors (>=
        0.12.2), knitr, testthat, readr, rmarkdown
Depends: R (>= 4.0)
LinkingTo: Rcpp, RcppEigen (>= 0.3.3.5.0)
RoxygenNote: 7.2.3
Encoding: UTF-8
biocViews: Software, GenomeWideAssociation, SNP, GeneticVariability,
        Genetics, FeatureExtraction, GraphAndNetwork, Network
VignetteBuilder: knitr
URL: https://github.com/hclimente/martini
BugReports: https://github.com/hclimente/martini/issues
git_url: https://git.bioconductor.org/packages/martini
git_branch: RELEASE_3_23
git_last_commit: 428b2d4
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: yes
Packaged: 2026-04-28 23:01:16 UTC; biocbuild
Author: Hector Climente-Gonzalez [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-3030-7471>),
  Chloe-Agathe Azencott [aut] (ORCID:
    <https://orcid.org/0000-0003-1003-301X>)
Maintainer: Hector Climente-Gonzalez <hector.climente@a.riken.jp>

# martini

![R-CMD-check-bioc](https://github.com/hclimente/martini/workflows/R-CMD-check-bioc/badge.svg)
[![codecov](https://codecov.io/gh/hclimente/martini/branch/master/graph/badge.svg)](https://codecov.io/gh/hclimente/martini)
[![BioC](https://bioconductor.org/shields/years-in-bioc/martini.svg)](https://bioconductor.org/packages/devel/bioc/html/martini.html)

`martini` is an R package to perform GWAS experiment that considers prior biological knowledge. This knowledge is modeled as a network of SNPs, were edges represent functional relationships between them (e.g. belonging to the same gene). Then, it looks for regions of the network associated with the phenotype using [SConES](https://academic.oup.com/bioinformatics/article/29/13/i171/198210) or [SigMod](https://academic.oup.com/bioinformatics/article/33/10/1536/2874362).

# Installation

Install `martini` like any other Bioconductor package:

``` r
install.packages("BiocManager")
BiocManager::install("martini")
```

# Usage

Running `martini` is a three step process:

``` r
library(martini)

# 1. Read GWAS data with read.pedfile (or load the example :) )
data(minigwas)

# 2. Create the SNP network: GS (structural information), GM (GS + gene 
# annotation information) or GI (GM + protein-protein interaction information)
gs <- get_GS_network(minigwas)

# 3. Run SConES, finding the best parameters by cross-validation
res <- scones.cv(minigwas, gs)

# the output is an igraph subnetwork containing the selected SNPs
res
# IGRAPH d9128a0 UNW- 12 10 -- 
# + attr: name (v/c), chr (v/n), pos (v/n), weight (e/n)
# + edges from d9128a0 (vertex names):
# [1] 1A1--1A2 1A2--1A3 1A3--1A4 1A4--1A5 1A5--1A6 2C1--2C2 2C2--2C3 2C3--2C4 2C4--2C5 2C5--2C6
```

Please, refer to the vignettes for more detailed usage examples. `martini` results can be further examined using the [blur](https://github.com/hclimente/blur) package.

# Citation

A more detailed description can be found in [the pre-print](https://www.biorxiv.org/content/10.1101/2021.01.25.428047v1). If you use `martini` in your work, please cite us:

```
@article{martini2021,
	title = {martini: an {R} package for genome-wide association studies using {SNP} networks},
  author = {Climente-González, Héctor and Azencott, Chloé-Agathe},
	url = {http://biorxiv.org/lookup/doi/10.1101/2021.01.25.428047},
	journal = {bioRxiv},
	month = jan,
	year = {2021},
	doi = {10.1101/2021.01.25.428047}
}
```

martINI
=======
        
martINI is an extended facility for utilizing
`ini files <http://en.wikipedia.org/wiki/INI_file>`_ in python.
martINI includes API, command-line, and web interfaces.
martINI is built on the
`ConfigParser <http://docs.python.org/library/configparser.html>`_ module,
which is part of python's standard library.


Command Line Tools
------------------

martINI comes with several command line tools for manipulating .ini
files:

 * ini-get: get key or section values from a .ini files
 * ini-set: set .ini file values 
 * ini-delete: delete .ini key-value pairs from a .ini files
 * ini-munge: combine several .ini files 

Running the commands will display usage information.


TODO
----

Consider refactoring to use 
`INITools <http://pythonpaste.org/initools/>`_ instead of ``ConfigParser``.

--

http://k0s.org/portfolio/software.html#martini

###################################################################
#                                                                 #
#    MAXFLOW - software for computing mincut/maxflow in a graph   #
#                        Version 3.03                             #
#    http://http://pub.ist.ac.at/~vnk/software.html               #
#                                                                 #
#    Yuri Boykov (yuri@csd.uwo.ca)                                #
#    Vladimir Kolmogorov (vnk@ist.ac.at)                          #
#    2001-2006                                                    #
#                                                                 #
###################################################################

1. Introduction.

This software library implements the maxflow algorithm described in

	"An Experimental Comparison of Min-Cut/Max-Flow Algorithms for Energy Minimization in Vision."
	Yuri Boykov and Vladimir Kolmogorov.
	In IEEE Transactions on Pattern Analysis and Machine Intelligence (PAMI), 
	September 2004

This algorithm was developed by Yuri Boykov and Vladimir Kolmogorov
at Siemens Corporate Research. To make it available for public use,
it was later reimplemented by Vladimir Kolmogorov based on open publications.

If you use this software for research purposes, you should cite
the aforementioned paper in any resulting publication.

----------------------------------------------------------------------

REUSING TREES:

Starting with version 3.0, there is a also an option of reusing search
trees from one maxflow computation to the next, as described in

	"Efficiently Solving Dynamic Markov Random Fields Using Graph Cuts."
	Pushmeet Kohli and Philip H.S. Torr
	International Conference on Computer Vision (ICCV), 2005

If you use this option, you should cite
the aforementioned paper in any resulting publication.

Tested under windows, Visual C++ 6.0 compiler and unix (SunOS 5.8
and RedHat Linux 7.0, GNU c++ compiler).

##################################################################

2. License & disclaimer.

    Copyright 2001-2006 Vladimir Kolmogorov (vnk@ist.ac.at), Yuri Boykov (yuri@csd.uwo.ca).

    This software is under the GPL license.
    If you require another license, you may consider using version 2.21
    (which implements exactly the same algorithm, but does not have the option of reusing search trees).

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
    "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
    LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
    A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
    OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
    SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
    LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
    DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
    (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
    OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

##################################################################

3. Example usage.

This section shows how to use the library to compute
a minimum cut on the following graph:

		        SOURCE
		       /       \
		     1/         \2
		     /      3    \
		   node0 -----> node1
		     |   <-----   |
		     |      4     |
		     \            /
		     5\          /6
		       \        /
		          SINK

///////////////////////////////////////////////////

#include <stdio.h>
#include "graph.h"

int main()
{
	typedef Graph<int,int,int> GraphType;
	GraphType *g = new GraphType(/*estimated # of nodes*/ 2, /*estimated # of edges*/ 1); 

	g -> add_node(); 
	g -> add_node(); 

	g -> add_tweights( 0,   /* capacities */  1, 5 );
	g -> add_tweights( 1,   /* capacities */  2, 6 );
	g -> add_edge( 0, 1,    /* capacities */  3, 4 );

	int flow = g -> maxflow();

	printf("Flow = %d\n", flow);
	printf("Minimum cut:\n");
	if (g->what_segment(0) == GraphType::SOURCE)
		printf("node0 is in the SOURCE set\n");
	else
		printf("node0 is in the SINK set\n");
	if (g->what_segment(1) == GraphType::SOURCE)
		printf("node1 is in the SOURCE set\n");
	else
		printf("node1 is in the SINK set\n");

	delete g;

	return 0;
}


///////////////////////////////////////////////////

#' Map SNPs to Ensembl genes.
#' 
#' @description Maps SNPs from a GWAS experiment to genes.
#' @template params_gwas
#' @template params_organism
#' @param flank A number with the flanking regions around genes to be considered
#' part of the gene i.e. SNPs mapped to them will be considered mapped to the
#' gene.
#' @return A data.frame with two columns: one for the SNP and another for the
#' gene it has been mapped to.
#' @keywords internal
snp2ensembl <- function(gwas, organism = 9606, flank = 0) {
  
  check_installed(c("IRanges", "httr", "biomaRt"), "snp2ensembl")
  
  # get map in appropriate format
  map <- sanitize_map(gwas)
  map[,'chr'] <- gsub("[Cc]hr", "", map[,'chr'])
  
  organism <- organism_id2name(organism)
  ensembl <- connect_biomart(organism)
  
  snp2gene <- by(map, map[,'chr'], function(snps) {
    
    # get genes in the range defined by the snps
    grange <- paste(unique(snps[,'chr']), 
                    min(snps[,'pos']) - flank, max(snps[,'pos']) + flank, 
                    sep = ":")
    genes <- biomaRt::getBM(
                   attributes = c("ensembl_gene_id","external_gene_name",
                                  "start_position","end_position"),
                   filters = c("chromosomal_region", "biotype"),
                   values = list(chromosomal_region=grange,
                                 biotype="protein_coding"), 
                   mart = ensembl)
    
    if(nrow(genes) == 0) {
      return()
    }
    
    # add a buffer before and after the gene
    genes$start_position <- genes$start_position - flank
    genes$start_position[genes$start_position < 0] <- 0
    genes$end_position <- genes$end_position + flank
    
    # convert to genomic ranges and check overlaps
    isnps <- with(snps, IRanges::IRanges(pos, width=1, names=snp))
    igenes <- with(genes, 
                   IRanges::IRanges(start_position, end_position, 
                                    names=ensembl_gene_id))
    olaps <- IRanges::findOverlaps(isnps, igenes)
    s2g <- cbind(snps[S4Vectors::queryHits(olaps),], 
                 genes[S4Vectors::subjectHits(olaps),])
    hasName <- s2g[,'external_gene_name'] == "" | 
               is.na(s2g[,'external_gene_name'])
    s2g$gene <- ifelse(hasName, s2g[,'ensembl_gene_id'], 
                                s2g[,'external_gene_name'])
    subset(s2g, select = c("snp", "gene"))
    
  })
  snp2gene <- do.call("rbind", snp2gene)
  
  return(snp2gene)
  
}

#' Get BioGRID protein-protein interactions.
#' 
#' @description Get all protein-protein interactions for an organism from
#' BioGRID.
#' @template params_organism
#' @return A data.frame with two columns with pairs of interacting proteins.
#' @examples 
#' # download dog interactions
#' \dontrun{martini:::get_gxg_biogrid(9615)}
#' @keywords internal
get_gxg_biogrid <- function(organism = 9606) {
  
  check_installed(c("httr"), "get_gxg_biogrid")
  
  # construct query: all interactions in the requested organism
  baseUrl <- "http://webservice.thebiogrid.org/interactions/?"
  query <- paste(baseUrl,
                 "accessKey=912520d90dba1547c01abf31a18bcc94",
                 "interSpeciesExcluded=true", 
                 "includeHeader=true", 
                 paste0("taxId=", organism), sep = "&")
  
  # number of results
  N <- httr::GET(paste(query, "format=count", sep = "&"))
  httr::stop_for_status(N)
  N <- as.numeric(
             httr::content(N, type="text/csv", encoding="UTF-8", col_types="i"))
  
  # retrieve results in batches
  ppi <- lapply(seq(1, N, 10000), function(i){
    q <- paste(query, paste0("start=", i), sep = "&")
    req <- httr::GET(q)
    httr::stop_for_status(req)
    
    # parse results
    biogrid <- httr::content(req, type="text/tab-separated-values", 
                             encoding="UTF-8", 
                             col_types="cccccccccccccccccccccccc")
    p <- subset(biogrid, select=c("Official Symbol Interactor A",
                                  "Official Symbol Interactor B"))
    colnames(p) <- c("gene1","gene2")
    return(p)
  })
  
  ppi <- do.call("rbind", ppi)
  ppi <- unique(ppi)
  
  return(ppi)
  
}

#' Get STRING protein-protein interactions.
#' 
#' @description Get all protein-protein interactions for an organism from
#' STRING. It uses a score cut-off of 400.
#' @template params_organism
#' @return A data.frame with two columns with pairs of interacting proteins.
#' @importFrom igraph as_edgelist
#' @examples 
#' # download frog interactions
#' \dontrun{martini:::get_gxg_string(8364)}
#' @keywords internal
get_gxg_string <- function(organism = 9606) {
  
  check_installed(c("STRINGdb", "httr", "biomaRt"), "get_gxg_string")
  
  string_db <- STRINGdb::STRINGdb$new(version = '11.5', species = organism,
                                      score_threshold = 400)
  
  # download ppi
  ppi <- string_db$get_graph()
  ppi <- as_edgelist(ppi)
  ppi <- as.data.frame(ppi)
  
  ppi[['V1']] <- gsub(paste0(organism, '.'), '', ppi[['V1']])
  ppi[['V2']] <- gsub(paste0(organism, '.'), '', ppi[['V2']])
  
  # convert protein ids to gene ids
  organism <- organism_id2name(organism)
  ensembl <- connect_biomart(organism)
  
  genes <- unique(c(ppi[['V1']], ppi[['V2']]))
  ensp2hgnc <- biomaRt::getBM(filters = "ensembl_peptide_id", 
        attributes = c("ensembl_peptide_id", "hgnc_symbol"),
        values = genes, mart = ensembl)
  ensp2hgnc <- ensp2hgnc[ensp2hgnc[["hgnc_symbol"]] != "",]
  
  ppi <- merge(ppi, ensp2hgnc, by.x = 'V1', by.y = "ensembl_peptide_id")
  ppi <- merge(ppi, ensp2hgnc, by.x = 'V2', by.y = "ensembl_peptide_id")
  ppi <- ppi[,c('hgnc_symbol.x', 'hgnc_symbol.y')]
  ppi <- unique(ppi)
  colnames(ppi) <- c("gene1","gene2")
  
  return(ppi)
}

#' Memoised version of get_gxg_biogrid
#' @inherit get_gxg_biogrid
#' @importFrom memoise memoise 
#' @keywords internal
mget_gxg_biogrid <- memoise::memoise(get_gxg_biogrid)

#' Memoised version of get_gxg_stringdb
#' @inherit get_gxg_string
#' @importFrom memoise memoise 
#' @keywords internal
mget_gxg_string <- memoise::memoise(get_gxg_string)

#' Get gene interactions
#' 
#' @description Wrapper for the different functions to get gene-gene 
#' interactions. Supports cached results.
#' @param db String containing the database to obtain the gene-gene interactions
#' from. Possible values: 'biogrid', 'string'.
#' @template params_organism
#' @template params_flush
#' @return A data.frame with two columns with pairs of interacting proteins.
#' @importFrom memoise drop_cache has_cache
#' @keywords internal
get_gxg <- function(db, organism, flush) {
  
  check_installed(c("biomaRt", "httr", "STRINGdb"), "get_gxg")
  
  if (db == 'biogrid') {
    f <- mget_gxg_biogrid
  } else if (db == 'string') {
    f <- mget_gxg_string
  } else {
    stop(paste('unknown gene interaction database', db))
  }
  
  if (memoise::has_cache(f)(organism)) {
    if (flush) {
      message('cache flushed!')
      memoise::drop_cache(f)(organism)
    } else {
      warning('using cache. Use flush = TRUE to get new gene interactions.')
    }
  }
  
  return(f(organism))
  
}

testthat::skip_on_bioc()
skip_if(skip_long)

library(martini)

good_dog <- martini:::get_gxg_biogrid(9615)
good_frog <- martini:::get_gxg_string(8364)

start <- proc.time()
suppressWarnings(dog <- martini:::get_gxg('biogrid', 9615, flush = TRUE))
t_dog <- proc.time() - start

start <- proc.time()
suppressWarnings(frog <- martini:::get_gxg('string', 8364, flush = TRUE))
t_frog <- proc.time() - start

test_that("output is as expected", {
  
  expect_equal(good_dog, dog)
  expect_equal(good_frog, frog)
  
})

test_that("cache works", {
  
  start <- proc.time()
  suppressWarnings(dog_cached <- martini:::get_gxg('biogrid', 9615, flush = FALSE))
  t_dog_cached <- proc.time() - start
  
  start <- proc.time()
  suppressWarnings(frog_cached <- martini:::get_gxg('string', 8364, flush = FALSE))
  t_frog_cached <- proc.time() - start
  
  # results are the same
  expect_equal(dog, dog_cached)
  expect_equal(frog, frog_cached)
  
  # elapsed time is reduced when we cache results
  expect_gt(t_dog['elapsed'], t_dog_cached['elapsed'])
  expect_gt(t_frog['elapsed'], t_frog_cached['elapsed'])
  
  # appropriate warnings
  expect_warning(martini:::get_gxg('biogrid', 9615, flush = FALSE),
                 "using cache. Use flush = TRUE to get new gene interactions.")
  expect_message(martini:::get_gxg('biogrid', 9615, flush = TRUE),
                 "cache flushed!")
  
  # appropriate errors
  expect_error(martini:::get_gxg('foo', 9615, flush = FALSE),
               "unknown gene interaction database foo")
  
})

library(martini)

# retrieve PPI from the dog, which in Biogrid 3.4.151 had 25 described interactions
dog <- martini:::get_gxg_biogrid(9615)

test_that("output is as expected", {
  
  # output
  expect_true(is.data.frame(dog))
  expect_equal(ncol(dog), 2)
  expect_equal(colnames(dog), c("gene1","gene2"))
  
  # we get the symbols
  expect_true("NEDD4" %in% c(dog$gene1, dog$gene2))
  expect_true("CREBBP" %in% c(dog$gene1, dog$gene2))
  expect_true("SP1" %in% c(dog$gene1, dog$gene2))
  
})

test_that("we retrieve known interactions", {
  
  # known interactions
  expect_equal(sum(dog$gene1 == "CREBBP" & dog$gene2 == "SP1"), 1)
  expect_equal(sum(dog$gene1 == "DTNA" & dog$gene2 == "ACTB"), 1)
  
  # expected order
  expect_equal(sum(dog$gene1 == "SP1" & dog$gene2 == "CREBBP"), 0)
  expect_equal(sum(dog$gene1 == "ACTB" & dog$gene2 == "DTNA"), 0)
  
})

testthat::skip_on_bioc()
skip_if(skip_long)

# SNPs from https://www.ebi.ac.uk/gwas/search?query=breast%20cancer
# mapped to fgfr2, tox3, fgfr2, none and none, respectively
brca <- list()
brca$map <- read.table(text = "
                       chr snp.name cm gpos allele.1 allele.2
                       10 rs2981579 0 121577821 A G
                       16 rs3803662 0 52552429 A G
                       10 rs2981582 0 121592803 A G
                       11 rs614367 0 69513996 A G
                       2 rs13387042 0 217041109 A G
                       ", header = TRUE, stringsAsFactors = FALSE)
brca$map$gpos <- as.numeric(brca$map$gpos)
brca_mapped <- martini:::snp2ensembl(brca)

# 7 snps from https://easygwas.ethz.ch/gwas/results/manhattan/view/4d00706f-ad0f-4f57-9f4e-ac3099b15b94/
# the last one was not assigned to any gene
athal <- list()
athal$map <- read.table(text = "
                       chr snp.name cm gpos allele.1 allele.2
                       4 Chr4_8297892 0 8297892 A G
                       4 Chr4_8297535 0 8297535 A G
                       4 Chr4_8301059 0 8301059 A G
                       4 Chr4_8300836 0 8300836 A G
                       4 Chr4_8254521 0 8254521 A G
                       4 Chr4_8274507 0 8274507 A G
                       5 Chr5_6485290 0 6485290 A G
                       ", header = TRUE, stringsAsFactors = FALSE)

athal$map$gpos <- as.numeric(athal$map$gpos)
athal_mapped <- martini:::snp2ensembl(athal, organism=3702)

test_that("output is as expected", {
  # dimensions
  expect_equal(ncol(brca_mapped), 2)

  # column order
  expect_equal(length(intersect(brca$map$snp.name, brca_mapped[,1])), 2)
  expect_equal(length(unique(brca_mapped[,2])), 1)
})

test_that("we map snps to their known genes", {

  # correct mapping in humans
  expect_equal(brca_mapped$gene[brca_mapped$snp == "rs2981579"], "FGFR2")
  expect_equal(brca_mapped$gene[brca_mapped$snp == "rs2981582"], "FGFR2")
  expect_equal(length(brca_mapped$gene[brca_mapped$snp == "rs13387042"]), 0)

  # correct mapping in arabidopsis
  expect_equal(athal_mapped$gene[athal_mapped$snp == "Chr4_8297892"], "ACD6")
  expect_equal(athal_mapped$gene[athal_mapped$snp == "Chr4_8297535"], "ACD6")
  expect_equal(athal_mapped$gene[athal_mapped$snp == "Chr4_8301059"], "bHLH104")
  expect_equal(athal_mapped$gene[athal_mapped$snp == "Chr4_8300836"], "bHLH104")
  expect_equal(athal_mapped$gene[athal_mapped$snp == "Chr4_8254521"], "AT4G14342")
  expect_equal(athal_mapped$gene[athal_mapped$snp == "Chr4_8274507"], "AT4G14368")
  expect_equal(length(athal_mapped$gene[athal_mapped$snp == "Chr5_6485290"]), 0)

  # check flanks
  # off by one base to FGFR2 10: 121,478,332-121,598,458 
  red <- list()
  red$map <- read.table(text = "
                       chr snp.name cm gpos allele.1 allele.2
                       10 outbound 0 121478331 A G
                       ", header = TRUE, stringsAsFactors = FALSE)
  red$map$gpos <- as.numeric(red$map$gpos)

  expect_equal(nrow(martini:::snp2ensembl(red, flank = 1)), 1)
  expect_equal(nrow(martini:::snp2ensembl(red)), NULL)

})

skip_if(skip_long)

ppi <- martini:::get_gxg_string(9606)

test_that("output is as expected", {
  
  # output
  expect_true(is.data.frame(ppi))
  expect_equal(ncol(ppi), 2)
  expect_equal(colnames(ppi), c("gene1","gene2"))
  
  # we get some known genes
  expect_true("TP53" %in% c(ppi$gene1, ppi$gene2))
  expect_true("AKT1" %in% c(ppi$gene1, ppi$gene2))
  expect_true("GAPDH" %in% c(ppi$gene1, ppi$gene2))
  
})

test_that("we retrieve known interactions", {
  
  # known interactions
  expect_equal(sum(ppi$gene1 == "KLF2" & ppi$gene2 == "TP53"), 1)
  expect_equal(sum(ppi$gene1 == "DUSP6" & ppi$gene2 == "AKT1"), 1)
  
  # expected order
  expect_equal(sum(ppi$gene1 == "TP53" & ppi$gene2 == "KLF2"), 0)
  expect_equal(sum(ppi$gene1 == "AKT1" & ppi$gene2 == "DUSP6"), 0)
  
})

#' Find connected explanatory SNPs.
#' 
#' @description Finds the SNPs maximally associated with a phenotype while being
#'  connected in an underlying network (Azencott et al., 2013).
#' @template params_gwas
#' @template params_net
#' @param encoding SNP encoding (unused argument).
#' @param sigmod Boolean. If TRUE, use the Sigmod variant of SConES, meant to 
#' prioritize tightly connected clusters of SNPs.
#' @template params_covars
#' @param associationScore Association score to measure association between 
#' genotype and phenotype.
#' @param modelScore String with the function to measure the quality of a split.
#' @template params_etas
#' @template params_lambdas
#' @template return_cones
#' @references Azencott, C. A., Grimm, D., Sugiyama, M., Kawahara, Y., & 
#' Borgwardt, K. M. (2013). Efficient network-guided multi-locus 
#' association mapping with graph cuts. Bioinformatics, 29(13), 171-179. 
#' \url{https://doi.org/10.1093/bioinformatics/btt238}
#' @importFrom igraph V
#' @examples
#' \dontrun{gi <- get_GI_network(minigwas, snpMapping = minisnpMapping, ppi = minippi)
#' search_cones(minigwas, gi)
#' search_cones(minigwas, gi, encoding = "recessive")
#' search_cones(minigwas, gi, associationScore = "skat")}
#' @export
search_cones <- function(gwas, net, encoding = "additive", sigmod = FALSE,
                         covars = data.frame(), 
                         associationScore = c("chi2", "glm"), 
                         modelScore = c("stability", "bic", "aic", "aicc", 
                                        "global_clustering", "local_clustering"), 
                         etas = numeric(), lambdas = numeric()) {
  
  .Deprecated('scones.cv')
  
  if (!missing("encoding"))
    warning("Argument encoding ignored, will be set to additive.")
  
  associationScore <- match.arg(associationScore)
  modelScore <- match.arg(modelScore)
  if (modelScore == 'consistency') modelScore <- 'stability'
  
  args <- list(gwas=gwas, net=net, covars=covars, score=associationScore, 
               criterion=modelScore, etas=etas, lambdas=lambdas)
  if(sigmod) subnet <- do.call(sigmod.cv, args)
  else subnet <- do.call(scones.cv, args)
  
  cones <- get_snp_modules(gwas, subnet)
  cones[['c']] <- snp_test(gwas, covars, associationScore)
  cones[['selected']] <- cones[['snp']] %in% names(V(subnet))
  
  return(cones)
  
}

#' Return groups of interconnected SNPs.
#' 
#' @description Find modules composed by interconnected SNPs.
#' 
#' @template params_gwas
#' @template params_net
#' @return A list with the modules of selected SNPs.
#' @importFrom igraph induced_subgraph components
#' @examples
#' \dontrun{
#' gi <- get_GI_network(minigwas, snpMapping = minisnpMapping, ppi = minippi)
#' cones <- search_cones(minigwas, gi)
#' martini:::get_snp_modules(cones, gi)
#' }
#' @keywords internal
get_snp_modules <- function(gwas, net) {
  
  # compute components
  modules <- components(net)
  modules <- as.data.frame(modules['membership'])
  colnames(modules) <- "module"
  modules['snp'] <- rownames(modules)
  
  # annotate on the map file
  map <- sanitize_map(gwas) 
  modules <- merge(map, modules, all.x = TRUE)
  map <- modules[match(map[,'snp'], modules[,'snp']),]
  
  return(map)
  
}

test_that("output is as expected", {
  
  suppressWarnings(cones <- search_cones(test_gwas, test_gi))
  
  expect_equal(dim(cones), dim(test_gwas$map) + c(0,3))
  expect_equal(class(cones), "data.frame")
  expect_equal(class(cones$selected), "logical")
  expect_equal(class(cones$c), "numeric")
  expect_equal(class(cones$module), "numeric")
  
})

test_that("search_cones calls the right function", {
 
  expect_warning(cones <- search_cones(test_gwas, test_gi),
                 "'search_cones' is deprecated.")
  expect_equal(sort(cones$snp[cones$selected]),
               sort(names(V(scones.cv(test_gwas, test_gi)))))
  
  suppressWarnings(cones <- search_cones(test_gwas, test_gi, sigmod = TRUE))
  expect_equal(sort(cones$snp[cones$selected]),
               sort(names(V(sigmod.cv(test_gwas, test_gi)))))
  
  expect_warning(search_cones(test_gwas, test_gi, encoding = 'foo'),
                 "Argument encoding ignored, will be set to additive.")
  
})

cones <- scones.cv(test_gwas, test_gm)
modules <- get_snp_modules(test_gwas, cones)

test_that("output has the right dimensions", {
  expect_equal(dim(modules), dim(test_gwas[['map']]) + c(0,1))
  expect_true("module" %in% colnames(modules))
})

test_that("snp order is kept", {
  expect_true(all(modules$snp == cones$snp))
})

test_that("we recover the designated modules", {
  expect_equal(unique(modules$module), c(1, NA, 2))
  expect_equal(unique(modules$module[grepl("A", modules$snp)]), 1)
  expect_equal(unique(modules$module[grepl("C", modules$snp)]), 2)
})

#' Ideogram of SConES results.
#'
#' @description Create a circular ideogram of the a network results using the
#' circlize package (Gu et al., 2014).
#' @template params_gwas
#' @template params_net
#' @template params_covars
#' @template params_genome
#' @return A circular ideogram, including the manhattan plot, and the
#' interactions between the selected SNPs.
#' @references Gu, Z., Gu, L., Eils, R., Schlesner, M., & Brors, B. (2014).
#' circlize Implements and enhances circular visualization in R. Bioinformatics
#' (Oxford, England), 30(19), 2811-2. 
#' \url{https://doi.org/10.1093/bioinformatics/btu393}
#' @importFrom igraph as_ids
#' @export
plot_ideogram <- function(gwas, net, covars = data.frame(), genome = "hg19") {
  
  check_installed(c("circlize", "IRanges"), "plot_ideogram")
  
  circlize::circos.initializeWithIdeogram(species = genome)
  
  bed <- gwas2bed(gwas)
  bed[['snp']] <- sanitize_map(gwas)[['snp']]
  bed[['c']] <- snp_test(gwas, covars, 'chi2')
  bed[['selected']] <- bed[['snp']] %in% names(V(net))
  # bring the selected snps to the front
  bed <- bed[with(bed, order(selected)),]
  
  circlize::circos.genomicTrackPlotRegion(
    bed,
    ylim = c(0, 1.1 * max(bed$c, na.rm = TRUE)),
    panel.fun = function(region, value, ...) {
      # color according to selection/non-selection
      col = ifelse(value[[3]], "#e84545", "#bad7df")
      circlize::circos.genomicPoints(region, value, col = col,
                                     cex = 0.5, pch = 16)
    }, 
    track.height = 0.3)
  
  # create edges
  edges <- as_ids(E(net))
  edges <- do.call(rbind, strsplit(edges, '|', fixed = TRUE))
  edges <- as.data.frame(edges)
  
  ## get positional information and remove self interactions
  edges <- merge(edges, bed, by.x = 'V1', by.y = 'snp')
  edges <- merge(edges, bed, by.x = 'V2', by.y = 'snp')
  edges <- edges[edges[['chr.x']] != edges[['chr.y']],]
  
  # group into regions
  edges <- cbind(group_snps(edges, "chr.x", "start.x", 50000),
                 group_snps(edges, "chr.y", "start.y", 50000))
  edges <- unique(edges)
  
  x1 <- edges[,c(1,2,3)]
  x2 <- edges[,c(4,5,6)]
  
  circlize::circos.genomicLink(x1, x2, col=sample(1:5, nrow(x1), replace=TRUE))
  circlize::circos.clear()
  
}

#' Groups nearby SNPs
#'
#' @description Groups SNPs closer than a specifiec threshold of distance.
#' @param bed data.frame containing at least two properties (chromosome and 
#' position) of a set of SNPs.
#' @param chr_col Name of the column containing the SNP chromosome.
#' @param pos_col Name of the column containing the SNP position.
#' @param threshold Maximum distance to group two SNPs group.
#' @return A data.frame in bed format, with the same dimensions as the original,
#' but with the groups.
#' @keywords internal
group_snps <- function(bed, chr_col, pos_col, threshold) {
  
  check_installed("IRanges", "group_snps")
  
  # make row numbers to reorder at the end
  bed[['id']]  <- 1:nrow(bed)
  
  ir_bed <- by(bed, bed[,chr_col], function(chr) {
    ir_chr <- IRanges::IRanges(start = chr[,pos_col], width = threshold)
    reduced_chr <- IRanges::reduce(ir_chr)
    ol <- as.matrix(IRanges::findOverlaps(ir_chr, reduced_chr))
    ir_chr[ol[,'queryHits'],] <- reduced_chr[ol[,'subjectHits'],]
    ir_chr <- as.data.frame(ir_chr)[,c('start','end')]
    ir_chr <- data.frame(chr_range   = chr[,chr_col],
                         start_range = ir_chr[['start']],
                         end_range   = ir_chr[['end']])
    unique(cbind(ir_chr, chr[,c(chr_col, pos_col)]))
          
  }) %>% do.call(rbind, .)
  
  bed <- merge(bed, ir_bed, by = c(chr_col, pos_col))
  bed[order(bed[['id']]), c('chr_range','start_range','end_range')]
  
}

bed <- gwas2bed(test_gwas)
bed <- bed[sample(nrow(bed)),]

test_that("output is as expected", {
  
  groups <- group_snps(bed, 'chr', 'start', 5)
  
  expect_type(groups, 'list')
  expect_type(groups[,1], 'character')
  expect_type(groups[,2], 'integer')
  expect_type(groups[,3], 'integer')
  expect_equal(ncol(groups), 3)
  expect_equal(colnames(groups), c('chr_range','start_range','end_range'))
  
})

test_that("we do group snps", {
  
  groups <- group_snps(bed, 'chr', 'start', 5)
  expect_true(any(groups[,1] == 'chr1' & groups[,2] == 60 & groups[,3] == 74))
  expect_true(any(groups[,1] == 'chr1' & groups[,2] == 110 & groups[,3] == 124))
  expect_true(any(groups[,1] == 'chr2' & groups[,2] == 35 & groups[,3] == 39))
  expect_true(any(groups[,1] == 'chr2' & groups[,2] == 75 & groups[,3] == 89))
  
})

test_that("threshold works properly", {
  
  # all SNPs are at distance <= 10 of another one
  groups <- group_snps(bed, 'chr', 'start', 11)
  expect_equal(nrow(unique(groups)), 2)
  
  # some SNPs are at distance 5 of another one
  groups <- group_snps(bed, 'chr', 'start', 5)
  expect_equal(nrow(unique(groups)), nrow(bed) - 6)
  
  # differences dissapear when going below 5
  groups <- group_snps(bed, 'chr', 'start', 4)
  expect_equal(nrow(unique(groups)), nrow(bed))
  
  # all SNPs are separated
  groups <- group_snps(bed, 'chr', 'start', 1)
  expect_equal(nrow(unique(groups)), nrow(bed))
  
})

#' @inherit scones.cv
#' @references Liu, Y., Brossard, M., Roqueiro, D., Margaritte-Jeannin, P., 
#' Sarnowski, C., Bouzigon, E., Demenais, F. (2017). SigMod: an exact and
#' efficient method to identify a strongly interconnected disease-associated
#' module in a gene network. Bioinformatics, 33(10), 1536–1544. 
#' \url{https://doi.org/10.1093/bioinformatics/btx004}
#' @examples
#' gi <- get_GI_network(minigwas, snpMapping = minisnpMapping, ppi = minippi)
#' sigmod.cv(minigwas, gi)
#' sigmod.cv(minigwas, gi, score = "glm")
#' @export
sigmod.cv <- function(gwas, net, covars = data.frame(),
                      score = c("chi2", "glm", "r2"), 
                      criterion = c("stability", "bic", "aic", "aicc", 
                                    "global_clustering", "local_clustering"), 
                      etas = numeric(), lambdas = numeric(),
                      family = c("binomial", "poisson", "gaussian", "gamma"), 
                      link = c("logit", "log", "identity", "inverse"),
                      max_prop_snp = 0.5) {

  score <- match.arg(score)
  criterion <- match.arg(criterion)
  family <- match.arg(family)
  link <- match.arg(link)
  c <- snp_test(gwas, covars, score, family, link)
  grid <- get_grid(c = c, etas, lambdas)
  
  return(mincut.cv(gwas, net, covars, grid[['etas']], grid[['lambdas']], 
                   criterion, score, TRUE, family, link, max_prop_snp))
  
}

#' @inherit scones
#' @references Liu, Y., Brossard, M., Roqueiro, D., Margaritte-Jeannin, P., 
#' Sarnowski, C., Bouzigon, E., Demenais, F. (2017). SigMod: an exact and
#' efficient method to identify a strongly interconnected disease-associated
#' module in a gene network. Bioinformatics, 33(10), 1536–1544. 
#' \url{https://doi.org/10.1093/bioinformatics/btx004}
#' @examples
#' gi <- get_GI_network(minigwas, snpMapping = minisnpMapping, ppi = minippi)
#' sigmod(minigwas, gi, 10, 1)
#' @export
sigmod <- function(gwas, net, eta, lambda, covars = data.frame(), 
                   score = c("chi2", "glm", "r2"), 
                   family = c("binomial", "poisson", "gaussian", "gamma"), 
                   link = c("logit", "log", "identity", "inverse")) {
  
  score <- match.arg(score)
  family <- match.arg(family)
  link <- match.arg(link)
  
  return(mincut(gwas, net, covars, eta, lambda, score, TRUE, family, link))
  
}

test_that("output is as expected", {
  
  cones <- sigmod(test_gwas, test_gi, 7.37, 0.202)
  cones.cv <- sigmod.cv(test_gwas, test_gi)
  
  expect_true(all(V(cones) == V(cones.cv)))
  expect_true(all(E(cones) == E(cones.cv)))
  
})

test_that("output is as expected", {
  
  cones <- sigmod.cv(test_gwas, test_gi)
  
  expect_equal(class(cones), "igraph")
  expect_true(all(names(V(cones)) %in% test_map$snp))
  
})

test_that("we recover causal SNPs", {
  
  cones <- sigmod.cv(test_gwas, test_gi, etas = 0, lambdas = 0)
  
  # wrong eta and lambda return the trivial solution
  expect_equal(gorder(cones), gorder(test_gi))
  
  set.seed(42)
  cones <- sigmod.cv(test_gwas, test_gi, 
                     etas = seq(2, 0, length=10), 
                     lambdas = seq(2, 0, length=10))
  
  skip_on_os("windows")
  expect_equal(gorder(cones), sum(grepl("[AC]", test_map$snp)))
  
  set.seed(42)
  cones <- sigmod.cv(test_gwas, test_gi, 
                     etas = seq(2, 0, length=10), 
                     lambdas = seq(2, 0, length=10),
                     criterion = 'bic')
  
  skip_on_os("windows")
  expect_equal(gorder(cones), sum(grepl("[AC]", test_map$snp)))
  expect_equal(sort(names(V(cones))), 
               sort(grep("[AC]", test_map$snp, value = TRUE)))
  
})

#' Description of the minigwas dataset.
#'
#' @name minigwas
#' @docType data
#' @description Small GWAS example.
#' @format A list with 3 items:
#' \describe{
#'   \item{genotypes}{Genotype and phenotype information.}
#'   \item{fam}{Simulated network.}
#'   \item{map}{Result of runing \code{find_cones} with gwas and net.}
#' }
#' @examples 
#' data(minigwas)
#' 
#' # access different elements
#' minigwas[["genotypes"]]
#' minigwas[["map"]]
#' minigwas[["fam"]]
NULL

#' Genes for the minigwas dataset.
#'
#' @name minisnpMapping
#' @docType data
#' @description data.frame that maps SNPs from minigwas to their gene.
#' @examples
#' data(minisnpMapping)
#' 
#' head(minisnpMapping)
NULL

#' PPIs for the minigwas dataset.
#'
#' @name minippi
#' @docType data
#' @description data.frame describing pairs of proteins that interact for 
#' minigwas.
#' @examples
#' data(minippi)
#' 
#' head(minippi)
NULL

#' Get genomic sequence network
#' 
#' @description Creates a network of SNPs where each SNP is connected to its 
#' adjacent SNPs in the genome sequence. Corresponds to the genomic sequence 
#' (GS) network described by Azencott et al.
#' @template params_gwas
#' @return An igraph network of the GS network of the SNPs.
#' @template reference_azencott
#' @importFrom igraph graph_from_data_frame simplify set_vertex_attr V
#' set_edge_attr
#' @importFrom stats aggregate
#' @importFrom utils combn head tail
#' @examples
#' get_GS_network(minigwas)
#' @export
get_GS_network <- function(gwas)  {
  
  map <- sanitize_map(gwas)
  map <- subset(map, select = c("chr","pos","snp"))
  map <- unique(map)
  map <- map[with(map, order(chr,pos)),]
  
  gs <- by(map, map[,'chr'], function(x){
    chr <- unique(x[,'chr'])
    snp1 <- head(x[,'snp'], n = length(x[,'snp']) - 1)
    snp2 <- tail(x[,'snp'], n = length(x[,'snp']) - 1)
    data.frame(snp1 = snp1, snp2 = snp2)
  })
  gs <- do.call(rbind, gs)
  gs <- graph_from_data_frame(gs, directed = FALSE)
  gs <- simplify(gs)
  
  gs <- set_vertex_attr(gs, "chr", 
                        index = match(map[,'snp'], V(gs)$name), map[,'chr'])
  gs <- set_vertex_attr(gs, "pos", 
                        index = match(map[,'snp'], V(gs)$name), map[,'pos'])
  gs <- set_edge_attr(gs, "weight", value = 1)

  return(gs)
  
}

#' Get gene membership network.
#' 
#' @description Creates a network of SNPs where each SNP is connected as in the
#' \link[=get_GS_network]{GS} network and, in addition, to all the other SNPs 
#' pertaining to the same gene. Corresponds to the gene membership (GM) network 
#' described by Azencott et al.
#' @template params_gwas
#' @template params_organism
#' @template params_snpMapping
#' @template params_col_genes
#' @return An igraph network of the GM network of the SNPs.
#' @template reference_azencott
#' @importFrom igraph %>% graph_from_data_frame simplify set_vertex_attr V
#' set_edge_attr
#' @importFrom utils combn
#' @examples 
#' get_GM_network(minigwas, snpMapping = minisnpMapping)
#' @export
get_GM_network <- function(gwas, organism = 9606, 
                           snpMapping = snp2ensembl(gwas, organism),
                           col_genes = c('snp','gene')) {
  
  snpMapping <- sanitize_snpMapping(snpMapping, col_genes) 
  map <- sanitize_map(gwas)
  
  gs <- get_GS_network(gwas)
  
  map <- merge(map, snpMapping)
  map <- subset(map, select = c("snp","gene"))
  # in some cases the same position is linked to two different variants
  map <- unique(map)
  map[,'snp'] <- as.character(map[,'snp'])
  map[,'gene'] <- as.character(map[,'gene'])
 
  # use only genes that map to more than 1 snp
  gene_freq <- table(map[,'gene'])
  genes <- names(gene_freq)[gene_freq > 1]
   
  if (length(genes)) {
    
    map <- subset(map, gene %in% genes)
    
    gm <- do.call(cbind, tapply(map[,'snp'], map[,'gene'], combn, 2)) %>% 
      t %>% 
      as.data.frame
    gm <- graph_from_data_frame(gm, directed = FALSE)
    gm <- simplify(gm + gs)
    gm <- set_vertex_attr(gm, 'gene', index = match(map[,'snp'], V(gm)$name), 
                          map[,'gene'])
    
    nGenes <- aggregate(gene ~ ., data=map, length)
    gm <- set_vertex_attr(gm, "nGenes", value = 0)
    gm <- set_vertex_attr(gm, "nGenes", 
                          index = match(nGenes[,'snp'], V(gm)$name),nGenes$gene)
  } else {
    warning("insufficient information to add gene information")
    gm <- gs
  }
  
  gm <- set_edge_attr(gm, "weight", value = 1)
  
  return(gm)
}

#' Get gene-interaction network.
#' 
#' @description Creates a network of SNPs where each SNP is connected as in the
#' \link[=get_GM_network]{GM} network and, in addition, to all the other SNPs 
#' pertaining to any interactor of the gene it is mapped to. Corresponds to the 
#' gene-interaction (GI) network described by Azencott et al.
#' 
#' @template params_gwas
#' @template params_organism
#' @template params_snpMapping
#' @param ppi A data.frame describing protein-protein interactions with at least
#' two colums. Gene ids must be the contained in snpMapping. Unless column names
#' are specified using \code{col_ppi}, involved columns must be named 
#' \code{gene1} and \code{gene2}.
#' @template params_col_genes
#' @param col_ppi Optional, length-2 character vector with the names of the two 
#' columns involving the protein-protein interactions.
#' @template params_flush
#' @return An igraph network of the GI network of the SNPs.
#' @template reference_azencott
#' @importFrom igraph graph_from_data_frame simplify set_edge_attr
#' @examples 
#' get_GI_network(minigwas, snpMapping = minisnpMapping, ppi = minippi)
#' @export
get_GI_network <- function(gwas, organism = 9606,
                           snpMapping = snp2ensembl(gwas, organism),
                           ppi = get_gxg('biogrid', organism, flush),
                           col_ppi = c('gene1','gene2'),
                           col_genes = c('snp','gene'),
                           flush = FALSE) {
  
  snpMapping <- sanitize_snpMapping(snpMapping, col_genes) 
  
  map <- sanitize_map(gwas)
  map <-  subset(map, select = c("chr","snp","pos"))
  
  # read tab file  
  ppi <- subset(ppi, select = col_ppi)
  colnames(ppi) <- c("gene1", "gene2")
  ppi <- unique(ppi)
  # remove self-interactions
  ppi <- subset(ppi, gene1 != gene2)
  
  # match all SNPs to pairwise PPI
  snpMapping <- subset(snpMapping, select = col_genes)
  colnames(snpMapping) <- c('snp','gene')
  snp2snp <- merge(ppi, snpMapping, by.x = "gene1", by.y = "gene")
  snp2snp <- merge(snp2snp, snpMapping, by.x = "gene2", by.y = "gene")
  snp2snp <- merge(snp2snp, map, by.x = "snp.x", by.y = "snp")
  snp2snp <- merge(snp2snp, map, by.x = "snp.y", by.y = "snp")
  
  if (nrow(snp2snp) == 0) {
    warning("no matches between genes in snpMapping and PPI. No information about PPI will be added.")
  }
  
  gi <- graph_from_data_frame(snp2snp, directed = FALSE)
  gm <- get_GM_network(gwas, snpMapping=snpMapping)
  gi <- simplify(gm + gi)
  
  gi <- set_edge_attr(gi, "weight", value = 1)
  
  return(gi)
  
}

test_that("we interconnect the right genes", {
  expect_true(igraph::are_adjacent(mini_gi, "rs1", "rs5"))
  expect_false(
    igraph::are_adjacent(
      get_GI_network(minimum_gwas, 
                     snpMapping = data.frame(snp = c("rs1", "rs2", "rs5", "rs6"),
                                             gene = c("A", "A", "C", "B"), 
                                             stringsAsFactors = FALSE),
                     ppi = data.frame(gene1 = "A", gene2 = "B", stringsAsFactors = FALSE)),
      "rs1", "rs5"))
})

test_that("we add genomic information to the vertices", {
  expect_equal(igraph::get.vertex.attribute(mini_gi, "chr", match(c("rs1", "rs2", "rs3"), igraph::V(mini_gi)$name) ), rep(1, 3) )
  expect_equal(igraph::get.vertex.attribute(mini_gi, "chr", match(c("rs4", "rs5", "rs6"), igraph::V(mini_gi)$name) ), rep(2, 3) )
  expect_equal(igraph::get.vertex.attribute(mini_gi, "pos", match(c("rs1", "rs2", "rs3"), igraph::V(mini_gi)$name) ), c(10, 20, 30) )
  expect_equal(igraph::get.vertex.attribute(mini_gi, "pos", match(c("rs4", "rs5", "rs6"), igraph::V(mini_gi)$name) ), c(15, 25, 35) )
})

test_that("we add gene information to the vertices", {
  expect_equal(igraph::get.vertex.attribute(mini_gi, "gene", match(c("rs1", "rs2"), igraph::V(mini_gi)$name) ), rep("A", 2) )
  expect_equal(igraph::get.vertex.attribute(mini_gi, "gene", match(c("rs5", "rs6"), igraph::V(mini_gi)$name) ), rep("B", 2) )
  expect_output(igraph::get.vertex.attribute(mini_gi, "gene", match("rs3", igraph::V(mini_gi)$name) ), NA )
  expect_output(igraph::get.vertex.attribute(mini_gi, "gene", match("rs4", igraph::V(mini_gi)$name) ), NA )
})

test_that("we are simplifying the network", { 
  
  s2g <- data.frame(snp = c("rs1", "rs2", "rs3", "rs4"),
                    gene = c("A", "A", "B", "B"), stringsAsFactors = FALSE)
  p <- data.frame(gene1 = "A", gene2 = "B", stringsAsFactors = FALSE)
  x <- igraph::as_adj(get_GI_network(minimum_gwas, snpMapping = s2g, ppi = p))
  
  expect_equal(sum(x != 0 & x != 1), 0)
  })

test_that("warns if ppi is insufficient to create a GI network", {
  expect_warning(get_GI_network(minimum_gwas, 
                                snpMapping = snpMapping, 
                                ppi = data.frame(gene1 = "A", gene2 = "A", stringsAsFactors = FALSE)), 
                 "no matches between genes in snpMapping and PPI. No information about PPI will be added.")
  expect_warning(get_GI_network(minimum_gwas, 
                                snpMapping = snpMapping, 
                                ppi = data.frame(gene1 = c("A", "B"), gene2 = c("A", "B"), stringsAsFactors = FALSE)), 
                 "no matches between genes in snpMapping and PPI. No information about PPI will be added.")
})

test_that("edges have weights", {
  expect_false(is.null(igraph::E(mini_gi)$weight))
})

test_that("we interconnect snps from a gene", {
  expect_true(igraph::are_adjacent(get_GM_network(minimum_gwas, snpMapping = data.frame(snp = c("rs1", "rs2"), gene = "1")), "rs1", "rs2"))
  expect_true(igraph::are_adjacent(get_GM_network(minimum_gwas, snpMapping = data.frame(snp = c("rs1", "rs2", "rs3"), gene = "1")), "rs1", "rs3"))
  expect_false(igraph::are_adjacent(get_GM_network(minimum_gwas, snpMapping = data.frame(snp = c("rs1", "rs2", "rs6"), gene = c("1","1","2"))), "rs1", "rs6"))
})

test_that("warns if snpMapping is insufficient to create a GM network", {
  expect_warning(get_GM_network(minimum_gwas, snpMapping = data.frame(snp = "rs1", gene = "A")), 
                 "insufficient information to add gene information")
  expect_warning(get_GM_network(minimum_gwas, snpMapping = data.frame(snp = c("rs1", "rs2"), gene = c("A", "B"))), 
                 "insufficient information to add gene information")
})

test_that("we add genomic information to the vertices", {
  expect_equal(igraph::get.vertex.attribute(mini_gm, "chr", match(c("rs1", "rs2", "rs3"), igraph::V(mini_gm)$name) ), rep(1, 3) )
  expect_equal(igraph::get.vertex.attribute(mini_gm, "chr", match(c("rs4", "rs5", "rs6"), igraph::V(mini_gm)$name) ), rep(2, 3) )
  expect_equal(igraph::get.vertex.attribute(mini_gm, "pos", match(c("rs1", "rs2", "rs3"), igraph::V(mini_gm)$name) ), c(10, 20, 30) )
  expect_equal(igraph::get.vertex.attribute(mini_gm, "pos", match(c("rs4", "rs5", "rs6"), igraph::V(mini_gm)$name) ), c(15, 25, 35) )
})

test_that("we add gene information to the vertices", {
  expect_equal(igraph::get.vertex.attribute(mini_gm, "gene", match(c("rs1", "rs2"), igraph::V(mini_gm)$name) ), rep("A", 2) )
  expect_equal(igraph::get.vertex.attribute(mini_gm, "gene", match(c("rs5", "rs6"), igraph::V(mini_gm)$name) ), rep("B", 2) )
  expect_output(igraph::get.vertex.attribute(mini_gm, "gene", match("rs3", igraph::V(mini_gm)$name) ), NA )
  expect_output(igraph::get.vertex.attribute(mini_gm, "gene", match("rs4", igraph::V(mini_gm)$name) ), NA )
  expect_equal(igraph::get.vertex.attribute(mini_gm, "nGenes", match("rs3", igraph::V(mini_gm)$name) ), 0 )
  expect_equal(igraph::get.vertex.attribute(mini_gm, "nGenes", match("rs10", igraph::V(mini_gm)$name) ), 1 )
  expect_equal(igraph::get.vertex.attribute(mini_gm, "nGenes", match("rs11", igraph::V(mini_gm)$name) ), 2 )
})

test_that("we are simplifying the network", { 
  
  s2g <- data.frame(snp = c("rs1", "rs2", "rs3", "rs4"),
                    gene = c("A", "A", "B", "B"), stringsAsFactors = FALSE)
  x <- igraph::as_adj(get_GM_network(minimum_gwas, snpMapping = s2g))
  
  expect_equal(sum(x != 0 & x != 1), 0)
})

test_that("edges have weights", {
  expect_false(is.null(igraph::E(mini_gm)$weight))
})

#' Subgraph of vertices with an attribute
#' 
#' @description Returns a subgraph matching some condition.
#' @param net An igraph network.
#' @param attr An attribute of the vertices.
#' @param values Possible values of \code{attr}.
#' @param affirmative Logical. States if a condition must be its affirmation 
#' (e.g. all nodes with gene name "X"), or its negation (all nodes not with gene
#' name "X").
#' @return A subgraph containing only the vertices with attribute equal to any
#' of the values in \code{values}.
#' @importFrom igraph induced_subgraph
#' @examples 
#' gi <- get_GI_network(minigwas, snpMapping = minisnpMapping, ppi = minippi)
#' martini:::subnet(gi, "gene", "A")
#' martini:::subnet(gi, "name", c("1A1", "1A3"))
#' @keywords internal
subnet <- function(net, attr, values, affirmative = TRUE) {
  vertices <- subvert(net, attr, values, affirmative)
  induced_subgraph(net, vertices)
}

#' Vertices with an attribute
#' 
#' @description Returns the nodes matching some condition.
#' @param net An igraph network.
#' @param attr An attribute of the vertices.
#' @param values Possible values of \code{attr}
#' @param affirmative Logical. States if a condition must be its affirmation 
#' (e.g. all nodes with gene name "X"), or its negation (all nodes not with gene
#' name "X").
#' @return The vertices with attribute equal to any of the values in
#' \code{values}.
#' @importFrom igraph V vertex_attr
#' @examples 
#' gi <- get_GI_network(minigwas, snpMapping = minisnpMapping, ppi = minippi)
#' martini:::subvert(gi, "gene", "A")
#' martini:::subvert(gi, "name", c("1A1", "1A3"))
subvert <- function(net, attr, values, affirmative = TRUE) {
  
  n_attr <- vertex_attr(net, attr)
  select <- (n_attr %in% values) == affirmative
  
  if (affirmative) {
    select <- !is.na(n_attr) & select
  }
  
  V(net)[select]
}

#' Check package is installed
#' 
#' @description Checks if a package is installed, launches an error if it is
#' not.
#' 
#' @param pkgs Character vector with the names of the packages.
#' @param fn Function calling the check.
#' @return The package is loaded into the namespace.
#' @examples 
#' martini:::check_installed(c("martini"))
#' \dontrun{martini:::check_installed("martinid")}
#' @keywords internal
check_installed <- function(pkgs, fn = "This function") {
  installed <- unlist(lapply(pkgs, requireNamespace, quietly = TRUE))
  if (!all(installed)) {
    stop(paste0(fn, " requires the following packages to be installed:\n", 
                paste(pkgs[!installed], collapse = '\n')), call. = FALSE)
  }
}

#' Check inner coherence of GWAS dataset
#' 
#' @description Checks that the different data structures have the SNPs in the 
#' same order.
#' @template params_gwas
#' @return TRUE if the GWAS dataset is coherent. Else, raises an error.
#' @examples 
#' martini:::is_coherent(minigwas)
#' @keywords internal
is_coherent <- function(gwas) {
  
  mapSelfCoherence <- by(gwas[["map"]], gwas[["map"]][,1], function(chr) {
    ascendingChr <- chr[order(chr[,4]),]
    descendingChr <- chr[order(chr[,4], decreasing = TRUE),]
    return(any(chr != ascendingChr) & any(chr != descendingChr))
  })
  
  if (any(mapSelfCoherence)) {
    stop("map is not ordered by genomic position.")
  }
  
  if (any(gwas[["map"]][,2] != colnames(gwas[["genotypes"]]))) {
    stop("map and genotype SNP order differ.")
  }
  
  return(TRUE)
  
}

#' Prepare covariates for \code{scones}
#' 
#' @description Prepares de covariates data.frame for the functions used in
#' \code{scones}, like \code{single_snp_association} or \code{score_folds}
#' .
#' @template params_gwas
#' @template params_covars
#' @return The covars data.frame, with the rows in the same order as gwas. 
#' @keywords internal
arrange_covars <- function(gwas, covars) {
  
  if (any(dim(covars))) {
    covars <- covars[match(row.names(gwas[['genotypes']]), covars[['sample']]),]
    covars <- subset(covars, select = -sample)
  }
  
  return(covars)

}

#' Permute samples
#' 
#' @description Compute a permutation of the samples of a snpMatrix object. 
#' Useful to make sure that the folds are not stratified by phenotype.
#' @template params_gwas
#' @keywords internal
permute_snpMatrix <- function(gwas) {
  
  n <- nrow(gwas[['genotypes']])
  perm <- sample(n)
  
  gwas[['genotypes']] <- gwas[['genotypes']][perm,]
  gwas[['fam']] <- gwas[['fam']][perm,]
  
  return(gwas)
  
}

#' Subsample snpMatrix
#' 
#' @description Compute a permutation of the samples of a snpMatrix object. 
#' Useful to make sure that the folds are not stratified by phenotype.
#' @template params_gwas
#' @param samples Vector (logical or numeric) containing the samples to select.
#' @keywords internal
subset_snpMatrix <- function(gwas, samples) {
  
  gwas[['genotypes']] <- gwas[['genotypes']][samples,]
  gwas[['fam']] <- gwas[['fam']][samples,]
  
  return(gwas)
  
}


#' Check snpMapping
#' 
#' @description Check that snpMapping is a proper data.frame.
#' 
#' @param snpMapping data.frame containing the correspondence between SNPs and
#' genes.
#' @param col_genes Length 2 character vector containing the colnames containing
#' the SNP and the gene ids, respectively.
#' @keywords internal
sanitize_snpMapping <- function(snpMapping, col_genes) {
  
  if(!is.null(snpMapping) && nrow(snpMapping)) {
    snpMapping <- subset(snpMapping, select = col_genes)
  } else {
    warning("no mappings between SNPs and genes were provided.")
    snpMapping <- data.frame(matrix(ncol = 2, nrow = 0))
  }
  colnames(snpMapping) <- c('snp','gene')
  
  return(snpMapping)
  
}

#' Check map
#' 
#' @description Check that map is a proper data.frame.
#' @template params_gwas
#' @keywords internal
sanitize_map <- function(gwas) {
  
  map <- gwas[["map"]]
  colnames(map) <- c("chr","snp","cm","pos","allele.1", "allele.2")
  
  return(map)
  
}

#' Tax id to ensembl species name
#' @description Converts taxid to ensembl species name e.g. human databases are 
#' hsapiens_*
#' @template params_organism
#' @keywords internal
organism_id2name <- function(id) {
  
  check_installed(c("httr"), "organism_id2name")
  
  urlTaxonomy <- "http://rest.ensembl.org/taxonomy"
  query <- paste0(urlTaxonomy,"/id/",id,"?content-type=application/json")
  name <- httr::GET(query)
  httr::stop_for_status(name)
  name <- httr::content(name,type ="application/json",encoding="UTF-8")
  name <- unlist(strsplit(name$name, " "))
  name <- tolower(paste0(substr(name[1], 1,1), name[2]))
  
  return(name)
  
}

#' Open a biomaRt connection
#' @description Opens a biomaRt connection for the relevant species.
#' @param organism String containing the ensembl species name (e.g. hsapiens 
#' for human)
#' @keywords internal
connect_biomart <- function(organism) {
  
  check_installed(c("biomaRt"), "connect_biomart")
  
  # create mart from ENSEMBL
  # consider vertebrates and plants
  conn <- tryCatch({
    datasetName <- paste0(organism, "_gene_ensembl")
    biomaRt::useEnsembl(biomart="ensembl", dataset=datasetName, mirror="useast")
  }, error = function(e){
    tryCatch({
      datasetName <- paste0(organism, "_eg_gene")
      biomaRt::useMart("plants_mart", host="plants.ensembl.org", 
                       dataset=datasetName)  
    }, error = function(e) {
      stop(paste0("unable to find an appropriate database for ", organism, "."))
    })
  })
  
  return(conn)
  
}

#' Compute Laplacian matrix
#' 
#' @template params_gwas
#' @template params_net
#' @return A Laplacian matrix.
#' @importFrom igraph simplify as_adj
#' @importFrom Matrix diag rowSums
#' @keywords internal
get_adjacency <- function(gwas, net) {
  
  map <- sanitize_map(gwas)
  
  # remove redundant edges and self-edges in network and sort
  net <- simplify(net)
  L <- as_adj(net, type="both", sparse = TRUE, attr = "weight")
  L <- L[map[['snp']], map[['snp']]]
  
  return(L)
  
}

#' Converts a MAP data.frame to a BED data.frame
#'
#' @description Takes a map file and:
#' \itemize{
#' \item{column 1: Used as the chromosome column in the BED file.}
#' \item{column 4: Used as start and end in the BED data.frame (as we work with
#' SNPs).}
#' }
#' @template params_gwas
#' @return A BED data.frame.
gwas2bed <- function(gwas) {
  
  map <- sanitize_map(gwas)
  bed <- subset(map, select = c("chr", "pos"))
  colnames(bed) <- c("chr", "start")
  bed$chr <- paste0("chr", bed$chr)
  bed$chr <- ifelse(bed$chr == "chr23", "chrX", bed$chr)
  bed$end <- bed$start
  
  return(bed)
  
}

library(martini)

test_that("detects when a package is not installed", {
  
  expect_error(check_installed(c("foo")), "This function requires the following packages to be installed:\nfoo")
  expect_error(check_installed(c("foo","bar"), "baz"), "baz requires the following packages to be installed:\nfoo\nbar")
  expect_error(check_installed("martini"), NA)
  
})

test_that("we get the right species", {
  expect_equal(martini:::organism_id2name(9606), "hsapiens")
  expect_equal(martini:::organism_id2name(3702), "athaliana")
  expect_equal(martini:::organism_id2name(167), "tsuccinifaciens")
})

test_that("subsets the right columns", {
 
  test_snpMapping <- data.frame(a = c('geneA'), b = c('trash'), c = c('snp1'))
  sanitized <- sanitize_snpMapping(test_snpMapping, c('c','a'))
  
  expect_equal(c(1,2), dim(sanitized))
  expect_equal(c('snp','gene'), colnames(sanitized))
  expect_equal('geneA', sanitized[1,'gene'])
  expect_equal('snp1', sanitized[1,'snp'])
  
})

test_that("warnings are correct", {
  
  expect_warning(sanitize_snpMapping(NULL, NULL),
                 "no mappings between SNPs and genes were provided.")
  expect_equal(c(0,2), dim(suppressWarnings(sanitize_snpMapping(NULL, NULL))))
  
})

library(martini)

suffledMap <- minigwas$map[sample(1:nrow(minigwas$map)), ]
shuffledGenotypes <- minigwas$genotypes[, suffledMap$snp.name]

test_that("we get errors when we should", {
  
  expect_true(is_coherent(minigwas))
  expect_error(is_coherent(list(map = suffledMap,
                                genotypes = minigwas$genotypes,
                                fam = minigwas$fam)),
               "map is not ordered by genomic position.")
  expect_error(is_coherent(list(map = minigwas$map,
                                genotypes = shuffledGenotypes,
                                fam = minigwas$fam)),
               "map and genotype SNP order differ.")
  
})

test_that("we recover all the SNPs we want", {
  
  subgi <- martini:::subvert(test_gi, "gene", "A")
  snpA <- grep("A", test_gwas$map$snp.name, value = TRUE)
  
  expect_true(all(names(subgi) %in% snpA))
  expect_true(all(snpA %in% names(subgi)))
  
})

test_that("we don't recover the SNPs we don't want", {
  
  subgi <- martini:::subvert(test_gi, "gene", "A", affirmative = FALSE)
  snpNotA <- grep("A", test_gwas$map$snp.name, value = TRUE, invert = TRUE)
  
  expect_true(all(names(subgi) %in% snpNotA))
  expect_true(all(snpNotA %in% names(subgi)))
  
})

testthat::skip_on_bioc()
skip_if(skip_long)

test_that("errors if a species is not in ensembl", {
  
  expect_error(martini:::connect_biomart("tsuccinifaciens"), 
               "unable to find an appropriate database for tsuccinifaciens.")
  
})

## ----load_martini-------------------------------------------------------------
library(martini)

## ----create_gi----------------------------------------------------------------
gi <- get_GI_network(minigwas, snpMapping = minisnpMapping, ppi = minippi)

## ----simulate_snps------------------------------------------------------------
causal <- simulate_causal_snps(gi, ngenes = 2, pcausal = 0.3)

par(mar=c(0,0,0,0)+.1)
plot(gi, mark.groups = names(causal))

## ----simulate_quantitative_phenotype------------------------------------------
# create a random 100x25 matrix of genotypes
X <- lapply(seq_len(100), function(i) { sample(c(0,1,2), 25, replace = TRUE) })
X <- do.call(rbind, X)

colnames(X) <- minigwas$map$snp.name
rownames(X) <- 1:nrow(X)

X <- X + 1
mode(X) <- "raw"
minigwas$genotypes <- new("SnpMatrix", X)

simulated <- simulate_phenotype(minigwas, snps = causal, h2 = 0.9)

## ----simulate_qualitative_phenotype-------------------------------------------
simulated <- simulate_phenotype(minigwas, snps = causal, h2 = 0.9, qualitative = TRUE,
                                ncases = 10, ncontrols = 40, prevalence = 0.2)

#' Make pseudo SnpMatrix object
#' 
#' @description Wrap design matrix and outcome vector into a pseudo SnpMatrix
#' object.
#' @template params_X
#' @template params_y
#' @template params_featnames
#' @template params_net
wrap_Xy <- function(X, y, featnames, net) {
  
  featnames_2 <- intersect(featnames, names(V(net)))
  
  gwas <- list('genotypes' = X[, featnames %in% featnames_2], 
               'fam' = data.frame(fam = 0,
                                  affected = y),
               'map' = data.frame(chr = 0, 
                                  snp = featnames[featnames %in% featnames_2], 
                                  cm = 0, 
                                  pos = 0, 
                                  allele.1 = 0, 
                                  allele.2 = 0))
  
  net <- induced_subgraph(net, featnames_2)
  net <- set_edge_attr(net, "weight", value=1)
  
  return(list(gwas = gwas, net = net))
  
}

#' Find connected explanatory features
#' 
#' @description Finds the features maximally associated with a phenotype while 
#' being connected in an underlying network. Select the hyperparameters by
#' cross-validation.
#' @template params_X
#' @template params_y
#' @template params_featnames
#' @template params_net
#' @template return_cones
#' @examples 
#' X <- as(minigwas[['genotypes']], 'numeric')
#' X <- X + matrix(rnorm(2500, sd = 0.1), nrow(X), ncol(X))
#' gi <- get_GI_network(minigwas, snpMapping = minisnpMapping, ppi = minippi)
#' scones.cv_(X, minigwas[['fam']]$affected, minigwas[['map']]$snp, gi)
#' @export
scones.cv_ <- function(X, y, featnames, net) {
  
    i <- wrap_Xy(X, y, featnames, net)
    scones.cv(i[['gwas']], i[['net']], score = 'r2')
  
}

#' Find connected explanatory features
#' 
#' @description Finds the features maximally associated with a phenotype while 
#' being connected in an underlying network.
#' @template params_X
#' @template params_y
#' @template params_featnames
#' @template params_net
#' @template params_eta
#' @template params_lambda
#' @template return_cones
#' @examples 
#' X <- as(minigwas[['genotypes']], 'numeric')
#' X <- X + matrix(rnorm(2500, sd = 0.1), nrow(X), ncol(X))
#' gi <- get_GI_network(minigwas, snpMapping = minisnpMapping, ppi = minippi)
#' scones_(X, minigwas[['fam']]$affected, minigwas[['map']]$snp, gi, 10, 1)
#' @export
scones_ <- function(X, y, featnames, net, eta, lambda) {
  
    i <- wrap_Xy(X, y, featnames, net)
    scones(i[['gwas']], i[['net']], eta, lambda, score = 'r2')
  
}

#' @inherit scones.cv_
#' @examples 
#' X <- as(minigwas[['genotypes']], 'numeric')
#' X <- X + matrix(rnorm(2500, sd = 0.1), nrow(X), ncol(X))
#' gi <- get_GI_network(minigwas, snpMapping = minisnpMapping, ppi = minippi)
#' sigmod.cv_(X, minigwas[['fam']]$affected, minigwas[['map']]$snp, gi)
#' @export
sigmod.cv_ <- function(X, y, featnames, net) {
  
  i <- wrap_Xy(X, y, featnames, net)
  sigmod.cv(i[['gwas']], i[['net']], score = 'r2')
  
}

#' @inherit scones_
#' @examples 
#' X <- as(minigwas[['genotypes']], 'numeric')
#' X <- X + matrix(rnorm(2500, sd = 0.1), nrow(X), ncol(X))
#' gi <- get_GI_network(minigwas, snpMapping = minisnpMapping, ppi = minippi)
#' sigmod_(X, minigwas[['fam']]$affected, minigwas[['map']]$snp, gi, 10, 1)
#' @export
sigmod_ <- function(X, y, featnames, net, eta, lambda) {
  
  i <- wrap_Xy(X, y, featnames, net)
  sigmod(i[['gwas']], i[['net']], eta, lambda, score = 'r2')
  
}

X <- X + matrix(rnorm(2500, sd = 0.1), nrow(X), ncol(X))

test_that("output is as expected", {
  
  cones <- sigmod.cv_(X, Y, test_gwas$map$snp.name, test_gi)
  
  expect_equal(class(cones), "igraph")
  expect_true(all(names(V(cones)) %in% test_map$snp))
  
})

test_that("we recover causal SNPs", {
  
  set.seed(42)
  cones <- sigmod.cv_(X, Y, test_gwas$map$snp.name, test_gi)
  
  skip_on_os("windows")
  expect_equal(gorder(cones), sum(grepl("[AC]", test_map$snp)))
  expect_equal(sort(names(V(cones))), 
               sort(grep("[AC]", test_map$snp, value = TRUE)))
  
})

test_that("output is as expected", {
  
  i <- martini:::wrap_Xy(X, Y, test_gwas$map$snp.name, test_gi)
  
  expect_equal(i[['gwas']][['genotypes']], X)
  expect_equal(i[['gwas']][['fam']]$affected, Y)
  expect_equal(i[['gwas']][['map']]$snp, test_gwas$map$snp.name)
  
  expect_true(all(V(test_gi) == V(i[['net']])))
  expect_true(all(E(test_gi) == E(i[['net']])))
  
})

#' Simulate causal SNPs
#' 
#' @description Selects randomly interconnected genes as causal, then selects a
#' proportion of them as causal.
#' 
#' @param net An igraph gene-interaction (GI) network that connects the SNPs.
#' @param ngenes Number of causal genes.
#' @param pcausal Number between 0 and 1, proportion of the SNPs in causal genes
#' that are causal themselves.
#' @return A vector with the ids of the simulated causal SNPs.
#' @importFrom igraph components V neighbors %>%
#' @importFrom stats na.omit
#' @examples 
#' gi <- get_GI_network(minigwas, snpMapping = minisnpMapping, ppi = minippi)
#' simulate_causal_snps(gi, ngenes=2)
#' @export
simulate_causal_snps <- function(net, ngenes = 20, pcausal = 1) {
  
  # SNPs with only one gene
  subnet <- subnet(net, "nGenes", 1)
  # genes with more than 1 SNP
  genes <- names(which(table(V(subnet)$gene) > 5))
  
  repeat {
    g <- sample(genes, 1)
    seed <- subvert(subnet, "gene", g)[1]
    
    causalGenes <- neighbors(subnet,seed)$gene %>% na.omit %>% unique
    causalGenes <- c(causalGenes, g)
    
    causalNetwork <- lapply(causalGenes, function(s) {
      subvert(subnet, "gene", s)$gene
    }) %>% unlist %>% table
    
    causalGenes <- causalNetwork[causalNetwork > ngenes/4] %>% names %>% 
                      intersect(genes) %>% head(ngenes)
    
    if ( length(causalGenes) >= ngenes ) {
      
      causal <- subvert(subnet, "gene", causalGenes)
      # sample a proportion pcausal of the snps in the causal genes
      causal <- sample(causal, length(causal) * pcausal)
      
      # check that we have at most two subnetworks
      if (components(subnet(net, "name", names(causal)))$no <= 2) {
        break
      }
    }
  }
  
  # get the nodes from the original net
  causal <- subvert(net, "name", names(causal))
  
  return(causal)
}

#' Simulate phenotype
#' 
#' @description Simulates a phenotype from a GWAS experiment and a specified set
#' of causal SNPs. If the data is qualitative, only controls are used.
#' 
#' @param gwas A SnpMatrix object with the GWAS information.
#' @param snps Character vector with the SNP ids of the causal SNPs. Must match
#' SNPs in gwas[["map"]][["snp.name"]].
#' @param h2 Heritability of the phenotype (between 0 and 1).
#' @param model String specifying the genetic model under the phenotype.
#' Accepted values: "additive".
#' @param effectSize Numeric vector with the same lenght as the number of causal
#' SNPs. It indicates the effect size of each of the SNPs; if absent, they are
#' sampled fron a normal distribution.
#' @param qualitative Bool indicating if the phenotype is qualitative or not
#' (quantitative).
#' @param ncases Integer specifying the number of cases to simulate in a
#' qualitative phenotype. Required if qualitative = TRUE.
#' @param ncontrols Integer specifying the number of controls to simulate in a
#' qualitative phenotype. Required if qualitative = TRUE.
#' @param prevalence Value between 0 and 1 specifying the population prevalence
#' of the disease. Note that ncases cannot be greater than 
#' prevalence * number of samples. Required if qualitative = TRUE.
#' @return A copy of the GWAS experiment with the new phenotypes in
#' \code{gwas[["fam"]][["affected"]]}.
#' @references Inspired from GCTA simulation tool:
#' \url{http://cnsgenomics.com/software/gcta/Simu.html}.
#' @importClassesFrom snpStats SnpMatrix
#' @importFrom methods as
#' @importFrom stats rnorm var
#' @importFrom utils head tail
#' @examples 
#' gi <- get_GI_network(minigwas, snpMapping = minisnpMapping, ppi = minippi)
#' causal <- simulate_causal_snps(gi, ngenes = 2)
#' simulate_phenotype(minigwas, causal, h2 = 1)
#' @export
simulate_phenotype <- function(gwas, snps, h2, model = "additive", 
                               effectSize = rnorm(length(snps)), 
                               qualitative = FALSE, 
                               ncases, ncontrols, prevalence){

  # select only controls
  binary <- (unique(gwas[["fam"]][["affected"]]) %>% length) == 2
  if (binary) {
    gwas[["genotypes"]] <- gwas[["genotypes"]][gwas[["fam"]][["affected"]]==1, ]
    gwas[["fam"]] <- gwas[["fam"]][gwas[["fam"]][["affected"]] == 1, ]
  }
  
  X <- as(gwas[["genotypes"]], "numeric")
  
  if (any(! names(snps) %in% gwas[["map"]][["snp.name"]])) {
    stop(paste("The following causal SNPs are not in the SNP list:", 
         paste(setdiff(names(snps), gwas[["map"]][["snp.name"]]), 
               collapse = ",")))
  }
  
  if (h2 < 0 | h2 > 1) {
    stop(paste0("h2 must be between 0 and 1. Current value is ", h2, "."))
  }
  
  X <- X[, names(snps)]
  G <- calculateG(effectSize, X, model)
  E <- calculateE(G, h2)
  Y <- G + E
  
  if (qualitative){
    if ( length(Y) < (ncases + ncontrols) ) {
      stop("Requested number of cases and controls too high (> # samples).")
    } else if ( prevalence * length(Y) < ncases ) {
      stop("Requested number of cases too high (> # samples * prevalence).")
    }
    
    Y.sorted <- sort(Y, index.return = TRUE)
    cases <- head(Y.sorted[['ix']], n = ncases)
    controls <- tail(Y.sorted[['ix']], n = ncontrols)

    Y[cases] <- 2
    Y[controls] <- 1
    Y[-c(cases,controls)] <- NA
    
  }
  
  gwas[["fam"]][["affected"]] <- Y
  
  return(gwas)
}

#' Calculate the genetic component of the phenotype
#' 
#' @description Calculates the genetic component of the phenotype from a
#' genotype.
#' 
#' @param effectSize A vector with the effect size of each SNP.
#' @param X Genotypes in a numeric matrix, where each row is a sample and each
#' column a SNP.
#' @param model Genetic model to assume.
#' @return A vector with the genetic component of each sample.
#' @keywords internal
calculateG <- function(effectSize, X, model) {
  
  X <- t(X)
  
  # calculate weights w
  p <- (2 * rowSums(X == 0, na.rm=TRUE) + rowSums(X == 1, na.rm=TRUE)) / (2 * ncol(X))
  x <- 2 * (X == 0) + (X == 1)
  w <- (x - 2 * p) / sqrt(2 * p * (1 - p))
  
  if (model == "additive") {
    G <- colSums(w * effectSize, na.rm = TRUE)
  } else {
    stop(paste0("Genetic model ", model, " not recognised."))
  }
  
  return(G)
  
}

#' Calculate the environmental component of the phenotype
#' 
#' @description Calculates the environmental component of the phenotype using
#' the variance in the genetic component.
#' 
#' @param G The genetic component of the phenotype.
#' @param h2 The heritability.
#' @return A vector with the environmental component of each sample.
#' @keywords internal
calculateE <- function(G, h2) {
  
  residual.var <- var(G) * (1/h2 - 1)
  residual <- rnorm(length(G), sd = sqrt(residual.var))
  
  return(residual)
  
}

library(martini)
load("examplegwas.rda")

set.seed(0)

# get 20 random snps and 20 random effect sizes
causal <- sample(igraph::V(examplegwas$net), 50)
eff <- rnorm(length(causal))
X <- as(examplegwas$gwas$genotypes, "numeric")
X_causal <- X[, examplegwas$gwas$map$snp.name %in% names(causal)]

# case-control phenotype
sim_cc <- simulate_phenotype(examplegwas$gwas, causal, h2 = 1, 
                             effectSize = eff, 
                             qualitative = TRUE, ncases = 1500, ncontrols = 1500, prevalence = 0.5)
# quantitative phenotype
sim <- simulate_phenotype(examplegwas$gwas, causal, h2 = 1, effectSize = eff)

test_that("output is as expected", {
  
  # right class
  expect_type(sim_cc, "list")
  expect_type(sim, "list")
  
  # only original controls are used
  expect_equal(nrow(sim_cc$fam), 3000)
  expect_equal(dim(sim_cc$genotypes), c(3000, 1800))
  expect_equal(nrow(sim$fam), 3000)
  expect_equal(dim(sim$genotypes), c(3000, 1800))
  
  # genotypes are still a SnpMatrix
  expect_equal(class(sim$genotypes)[1], "SnpMatrix")
  expect_equal(class(sim_cc$genotypes)[1], "SnpMatrix")
  
})

test_that("we get the requested number of phenotypes", {
  
  expect_equal(sum(is.na(sim_cc)), 0)
  expect_equal(sum(is.na(sim)), 0)
  
  # less requested cases and controls than the total number of samples
  expect_equal(sum(is.na(simulate_phenotype(examplegwas$gwas, causal, h2 = 1, 
                                            effectSize = eff, qualitative = TRUE, 
                                            ncases = 1400, ncontrols = 1350, 
                                            prevalence = 0.5)$fam$affected)), 250)
  
})

test_that("there is an association between phenotype and genotype", {
  
  cc_p <- apply(X_causal, 2, function(x){
    df <- data.frame(p = sim_cc$fam$affected, g = x)
    chsq <- chisq.test(table(df))
    chsq$p.value
  })
  expect_gt(sum(cc_p < 0.05), 20)
  
  qt_p <- apply(X_causal, 2, function(x){
    wilcox.test(sim$fam$affected, x)$p.value
  })
  expect_gt(sum(qt_p < 0.05), 20)
  
})

test_that("errors when it should", {
  
  badCausal <- sample(igraph::V(test_gi), 10)
  
  # general errors
  expect_error(simulate_phenotype(examplegwas$gwas, badCausal, h2 = 1, effectSize = eff),
               paste("The following causal SNPs are not in the SNP list:", 
                     paste(names(badCausal), collapse = ",")), fixed=TRUE)
  expect_error(simulate_phenotype(examplegwas$gwas, causal, h2 = 1.5, effectSize = eff),
               "h2 must be between 0 and 1. Current value is 1.5.", fixed=TRUE)
  expect_error(simulate_phenotype(examplegwas$gwas, causal, h2 = -1.5, effectSize = eff),
               "h2 must be between 0 and 1. Current value is -1.5.", fixed=TRUE)
  
  # errors related to qualitative phenotypes
  expect_error(simulate_phenotype(examplegwas$gwas, causal, h2 = 1, effectSize = eff, qualitative = TRUE), 
               'argument "ncases" is missing, with no default', fixed=TRUE)
  expect_error(simulate_phenotype(examplegwas$gwas, causal, h2 = 1, effectSize = eff, qualitative = TRUE, ncases = 1e4), 
               'argument "ncontrols" is missing, with no default', fixed=TRUE)
  expect_error(simulate_phenotype(examplegwas$gwas, causal, h2 = 1, effectSize = eff, qualitative = TRUE, ncases = 1500, ncontrols = 1500), 
               'argument "prevalence" is missing, with no default', fixed=TRUE)
  expect_error(simulate_phenotype(examplegwas$gwas, causal, h2 = 1, effectSize = eff, qualitative = TRUE, ncases = 1e4, ncontrols = 1e4, prevalence = 0.1), 
               "Requested number of cases and controls too high (> # samples).", fixed=TRUE)
  expect_error(simulate_phenotype(examplegwas$gwas, causal, h2 = 1, effectSize = eff, qualitative = TRUE, ncases = 1500, ncontrols = 1500, prevalence = 0.1), 
               "Requested number of cases too high (> # samples * prevalence).", fixed=TRUE)
  
})

library(martini)

# GI network
causal2 <- simulate_causal_snps(test_gi, 2)
causal3 <- simulate_causal_snps(test_gi, 3)

test_that("we get causal SNPs from two different genes", {
  expect_equal(intersect(causal2$gene, c("A", "B", "C")) %>% length(), 2)
  expect_equal(intersect(causal3$gene, c("A", "B", "C")) %>% length(), 3)
})

test_that("genes with less than 6 single-gene SNPs are discarded", {
  expect_false("D" %in% causal2$gene)
  expect_false("D" %in% causal3$gene)
})

test_that("SNPs are interconnected", {
  expect_equal((igraph::components(igraph::induced_subgraph(test_gi, names(causal2))) %>% 
                .$membership %>% 
                unique), 1 )
  expect_equal((igraph::components(igraph::induced_subgraph(test_gi, names(causal3))) %>% 
                  .$membership %>% 
                  unique), 1 )
})

half <- simulate_causal_snps(test_gi, 2, 0.5)
test_that("we can modulate the proportion of SNPs", {
  expect_equal(length(causal2), length(half) * 2)
})

library(martini)

test_that("E has the expected output", {
  
  expect_equal(length(calculateE(rnorm(322), 0.25)), 322)
  expect_equal(length(calculateE(rnorm(7), 0.25)), 7)
  expect_equal(class(calculateE(rnorm(7), 0.25)), "numeric")
  
})

test_that("E depends on variance in genotypes", {
  
  expect_equal(calculateE(rep(1,10), 1), rep(0,10))
  expect_equal(calculateE(rep(5.5,10), 1), rep(0,10))
  
})

test_that("E depends on heritability", {
  
  G <- rnorm(100)
  expect_true(var(calculateE(G, 0.25)) > var(calculateE(G, 0.75)))
  
})

library(martini)

test_that("effect size modulates the effect", {
  
  X <- matrix(c(0,1,2), 3, 1)
  G1 <- calculateG(1, X, "additive")
  G2 <- calculateG(2, X, "additive")
  G3 <- calculateG(3, X, "additive")
  
  expect_true(all(G1 * 2 == G2))
  expect_true(all(G1 * 3 == G3))
  
})

test_that("SNP frequency modulates the effect", {
  
  X <- matrix(c(0,1,2), 3, 1)
  G <- calculateG(1, X, "additive")
  
  # check that samples with the same number of minor alleles have the same effect
  expect_equal(G[1], -G[3])
  expect_equal(G[2], 0)

  sorted <- sort(rowSums(X), decreasing = TRUE, index.return=TRUE)$ix

  # check that more SNPs result in stronger effects
  expect_false(is.unsorted(G[sorted]))
  
})

test_that("additive effects are the sum of the effects of individual SNPs", {
  
  X1 <- matrix(c(0,1,2), 3, 1)
  X2 <- matrix(c(1,1,2), 3, 1)
  X3 <- matrix(c(0,2,2), 3, 1)
  X <- cbind(X1, X2, X3)
  
  u <- c(1, 3.5, 2.1)
  
  G1 <- calculateG(u[1], X1, "additive")
  G2 <- calculateG(u[2], X2, "additive")
  G3 <- calculateG(u[3], X3, "additive")
  G <- calculateG(u, X, "additive")
  
  expect_equal(G, G1 + G2 + G3)
  
})

test_that("errors when it should", { 
  
  X <- matrix(c(0,1,2), 3, 1)
  
  expect_error(calculateG(1, X, "xyz"), "Genetic model xyz not recognised.", fixed=TRUE)
  
})

#' Include linkage disequilibrium information in the network.
#' 
#' @description Include linkage disequilibrium information in the SNP network. 
#' The weight of the edges will be lower the higher the linkage is.
#' 
#' @param net A SNP network.
#' @param ld A \code{dsCMatrix} or \code{dgCMatrix} containing linkage 
#' disequilibrium measures, like the output of \code{\link[snpStats]{ld}}.
#' @param method How to incorporate linkage-disequilibrium values into the 
#' network.
#' @return An copy of net where the edges weighted according to linkage 
#' disequilibrium.
#' @importFrom igraph E %>% set_edge_attr delete_edges get.edgelist
#' @importFrom Matrix summary
#' @importFrom stats cor
#' @examples 
#' ld <- snpStats::ld(minigwas[['genotypes']], depth = 2, stats = "R.squared")
#' # don't weight edges for which LD cannot be calculated
#' ld[is.na(ld)] <- 0
#' gi <- get_GI_network(minigwas, snpMapping = minisnpMapping, ppi = minippi)
#' ldGi <- ldweight_edges(gi, ld)
#' @export
ldweight_edges <- function(net, ld, method = "inverse") {
    
    edges <- as.data.frame(get.edgelist(net))
    edges <- paste(edges[,1], edges[,2], sep = "-")
    ldDf <- Matrix::summary(ld)
    ldDf[['key']] <- paste(rownames(ld)[ldDf[['i']]], 
                           rownames(ld)[ldDf[['j']]], sep = "-")
    ldDf <- ldDf[ldDf[['key']] %in% edges, ]
    idx <- match(ldDf[['key']], edges)
    
    net <- switch(method,
        inverse = set_edge_attr(net, "weight", index = idx, 
                                value = 1 / (1 + ldDf[['x']])),
        subtraction = set_edge_attr(net, "weight", index = idx,
                                    value = 1 - ldDf[['x']]),
        sigmoid = set_edge_attr(net, "weight", index = idx, 
                                value = 1 / (1 + exp(10*(ldDf[['x']] - 0.5)))))

    if (any(is.na(E(net)$weight))) {
        stop("NA values as edge weights.")
    } else if (any(E(net)$weight < 0)) {
        stop("Edge weights cannot be negative.")
    }
    
    # remove edges with 0 weight
    zeroE <- E(net)[E(net)$weight == 0]
    net <- delete_edges(net, zeroE)
    
    return(net)
    
}

load("examplegwas.rda")

gwas <- examplegwas[['gwas']]
ld <- Matrix::sparseMatrix(i = c(1,1,2), j = c(1,3,3), x = c(0, 1, 0.5), symmetric = TRUE)
colnames(ld) <- c("rs1101", "rs1102", "rs1103")
rownames(ld) <- colnames(ld)

snps <- data.frame(snp1 = c("rs1101","rs1101","rs1102"),
                   snp2 = c("rs1102","rs1103","rs1103"))
net <- igraph::graph_from_data_frame(snps, directed = FALSE)
net <- igraph::set_edge_attr(net, "weight", value = 1)

# subtraction tests
ldnet <- ldweight_edges(net, ld, method = "subtraction")
ldnetDf <- igraph::as_data_frame(ldnet)

test_that("snps in perfect ld are disconnected", {
  expect_false(igraph::are_adjacent(ldnet, "rs1101", "rs1103"))
  expect_equal(length(igraph::E(ldnet)), 2)
})

test_that("snps not in perfect ld connected", {
  expect_true(all(igraph::E(ldnet) %in% igraph::E(net)))
  expect_equal(subset(ldnetDf, from == "rs1101" & to == "rs1102")$weight, 1)
  expect_equal(subset(ldnetDf, from == "rs1102" & to == "rs1103")$weight, 0.5)
})

test_that("negative and NAs are not possible", {
  
  ld <- Matrix::sparseMatrix(i = c(1,1,2), j = c(1,3,3), x = c(0, 2, 0.5), symmetric = TRUE)
  colnames(ld) <- c("rs1101", "rs1102", "rs1103")
  rownames(ld) <- colnames(ld)
  expect_error(ldweight_edges(net, ld, method = "subtraction"),
               "Edge weights cannot be negative.")
  
  ld <- Matrix::sparseMatrix(i = c(1,1,2), j = c(1,3,3), x = c(NA, NA, NA), symmetric = TRUE)
  colnames(ld) <- c("rs1101", "rs1102", "rs1103")
  rownames(ld) <- colnames(ld)
  expect_error(ldweight_edges(net, ld, method = "subtraction"),
               "NA values as edge weights.")
  
})

# inverse tests
ldnet <- ldweight_edges(net, ld, method = "inverse")
ldnetDf <- igraph::as_data_frame(ldnet)

test_that("edges have the apropriate values", {
  expect_equal(length(igraph::E(ldnet)), 3)
  expect_true(all(igraph::E(net) %in% igraph::E(ldnet)))
  expect_equal(subset(ldnetDf, from == "rs1101" & to == "rs1102")$weight, 1)
  expect_equal(subset(ldnetDf, from == "rs1101" & to == "rs1103")$weight, 0.5)
  expect_equal(subset(ldnetDf, from == "rs1102" & to == "rs1103")$weight, 2/3)
})

test_that("negative and NAs are not possible", {
  
  ld <- Matrix::sparseMatrix(i = c(1,1,2), j = c(1,3,3), x = c(0, -10, 0.5), symmetric = TRUE)
  colnames(ld) <- c("rs1101", "rs1102", "rs1103")
  rownames(ld) <- colnames(ld)
  expect_error(ldweight_edges(net, ld, method = "inverse"),
               "Edge weights cannot be negative.")
  
  ld <- Matrix::sparseMatrix(i = c(1,1,2), j = c(1,3,3), x = c(NA, NA, NA), symmetric = TRUE)
  colnames(ld) <- c("rs1101", "rs1102", "rs1103")
  rownames(ld) <- colnames(ld)
  expect_error(ldweight_edges(net, ld, method = "inverse"),
               "NA values as edge weights.")
  
})

# sigmoid tests
ldnet <- ldweight_edges(net, ld, method = "sigmoid")
ldnetDf <- igraph::as_data_frame(ldnet)

test_that("edges have the apropriate values", {
  expect_equal(length(igraph::E(ldnet)), 3)
  expect_true(all(igraph::E(net) %in% igraph::E(ldnet)))
  expect_equal(subset(ldnetDf, from == "rs1101" & to == "rs1102")$weight, 1)
  expect_equal(subset(ldnetDf, from == "rs1101" & to == "rs1103")$weight, 1 / (1 + exp(10*(1 - 0.5))))
  expect_equal(subset(ldnetDf, from == "rs1102" & to == "rs1103")$weight, 1 / (1 + exp(10*(0.5 - 0.5))))
})

library(igraph)
library(martini)

# make snpMatrix
## map
test_gwas <- list()
test_gwas$map <- read.table(text = "
                       chr snp.name cm gpos allele.1 allele.2
                       1 1A1 0 10 A G
                       1 1A2 0 20 A G
                       1 1A3 0 30 A G
                       1 1A4 0 40 A G
                       1 1A5 0 50 A G
                       1 1A6 0 60 A G
                       1 1-1 0 65 A G
                       1 1B1 0 70 A G
                       1 1B2 0 80 A G
                       1 1B3 0 90 A G
                       1 1B4 0 100 A G
                       1 1B5 0 110 A G
                       1 1B6 0 115 A G
                       1 1-2 0 120 A G
                       2 2C1 0 35 A G
                       2 2C2 0 45 A G
                       2 2C3 0 55 A G
                       2 2C4 0 65 A G
                       2 2C5 0 75 A G
                       2 2C6 0 80 A G
                       2 2-1 0 85 A G
                       2 2-2 0 95 A G
                       2 2D1 0 105 A G
                       2 2D2 0 115 A G
                       2 2D3 0 125 A G
                       ", header = TRUE, stringsAsFactors = FALSE)

## genotypes
N <- 100
sol <- grepl("[AC]", test_gwas$map$snp.name)
pCausal <- sum(sol)
pNonCausal <- nrow(test_gwas$map) - pCausal
causal <- c(rep(2, N/2), rep(0, N/2))
rest <- rep(0,N)

X <- do.call(cbind, lapply(sol, function(x) if(x) causal else rest))
colnames(X) <- test_gwas$map$snp.name
rownames(X) <- 1:nrow(X)
Xp <- X + 1
# create some heterogeneity
diag(Xp) = 2
mode(Xp) <- "raw"
test_gwas$genotypes <- new("SnpMatrix", Xp)

## phenotypes
Y <- c(rep(2, N/2), rep(1, N/2))
test_gwas$fam <- data.frame(pedigree = 1:N,
                       member = 1:N,
                       father = NA,
                       mother = NA,
                       sex = sample(c(1,2), N, replace = TRUE),
                       affected = Y)

# make snp networks
snpMapping <- data.frame(snp = test_gwas$map$snp.name,
                         gene = substr(test_gwas$map$snp.name, 2, 2))
snpMapping <- subset(snpMapping, gene != "-")
ppi <- read.table(text = "
                  gene1 gene2
                  A B
                  A C
                  B D
                  ", header = TRUE, stringsAsFactors = FALSE)

test_gs <- get_GS_network(test_gwas)
test_gm <- get_GM_network(test_gwas, snpMapping = snpMapping)
test_gi <- get_GI_network(test_gwas, snpMapping = snpMapping, ppi = ppi)
test_map <- martini:::sanitize_map(test_gwas)

# make covariates
genotypes <- test_gwas[['genotypes']]
phenotypes <- test_gwas[['fam']][['affected']]
covars <- data.frame(sample = sort(test_gwas[['fam']][['member']], decreasing = TRUE), 
                     confounding = c(rep(1, nrow(genotypes)/2), rep(10, nrow(genotypes)/2)) + rnorm(nrow(genotypes), sd = .01),
                     unrelated = c(rep(1, nrow(genotypes))) + rnorm(nrow(genotypes), sd = .01))

# CREATE MINI
# minigwas = gwas
# minigs = gs
# minigm = gm
# minigi = gi
# miniX = X
# miniY = Y
# miniW = W
# minisnpMapping = snpMapping
# minippi = ppi
# miniSolution = solution
# 
# save(minigwas, file = "data/minigwas.rda")
# save(minigs, file = "data/minigs.rda")
# save(minigm, file = "data/minigm.rda")
# save(minigi, file = "data/minigi.rda")
# save(miniX, file = "data/miniX.rda")
# save(miniY, file = "data/miniY.rda")
# save(miniW, file = "data/miniW.rda")
# save(minisnpMapping, file = "data/minisnpMapping.rda")
# save(minippi, file = "data/minippi.rda")
# save(miniSolution, file = "data/miniSolution.rda")

#' Find connected explanatory SNPs.
#' 
#' @description Finds the SNPs maximally associated with a phenotype while being
#' connected in an underlying network. Select the hyperparameters by
#' cross-validation.
#' @template params_gwas
#' @template params_net
#' @template params_covars
#' @template params_score
#' @template params_criterion
#' @template params_etas
#' @template params_lambdas
#' @template return_cones
#' @template params_family
#' @template params_link
#' @template reference_azencott
#' @template params_max_prop_snp
#' @examples
#' gi <- get_GI_network(minigwas, snpMapping = minisnpMapping, ppi = minippi)
#' scones.cv(minigwas, gi)
#' scones.cv(minigwas, gi, score = "glm")
#' @export
scones.cv <- function(gwas, net, covars = data.frame(), 
                      score = c("chi2", "glm", "r2"), 
                      criterion = c("stability", "bic", "aic", "aicc", 
                                    "global_clustering", "local_clustering"), 
                      etas = numeric(), lambdas = numeric(),
                      family = c("binomial", "poisson", "gaussian", "gamma"), 
                      link = c("logit", "log", "identity", "inverse"),
                      max_prop_snp = 0.5) {
  
  # set options
  score <- match.arg(score)
  criterion <- match.arg(criterion)
  family <- match.arg(family)
  link <- match.arg(link)
  c <- snp_test(gwas, covars, score, family, link)
  grid <- get_grid(c = c, etas, lambdas)
  
  return(mincut.cv(gwas, net, covars, grid[['etas']], grid[['lambdas']], 
                   criterion, score, FALSE, family, link, max_prop_snp))
  
}

#' Run the cross-validated min-cut algorithm
#'
#' @template params_gwas
#' @template params_net
#' @template params_covars
#' @template params_family
#' @template params_link
#' @importFrom utils capture.output
#' @keywords internal
mincut.cv <- function(gwas, net, covars, etas, lambdas, criterion, score, 
                      sigmod, family, link, max_prop_snp) {
  
  # prepare data
  gwas <- permute_snpMatrix(gwas)
  A <- get_adjacency(gwas, net)
  
  # grid search
  K <- cut(seq(1, nrow(gwas[['fam']])), breaks = 10, labels = FALSE)
  folds <- lapply(unique(K), function(k) {
    
    gwas_k <- subset_snpMatrix(gwas, (K!=k))
    covars_k <- arrange_covars(gwas_k, covars)
    c_k <- snp_test(gwas_k, covars_k, score, family, link)
    
    lapply(lambdas, function(lambda) {
      c_k <- if (sigmod) c_k + lambda * rowSums(A) else c_k
      lapply(etas, function(eta) {
        selected_k <- mincut_c(c_k, eta, lambda, A)
        score_fold(gwas_k, covars_k, net, selected_k, criterion, max_prop_snp)
      })
    })
  })
  
  grid <- matrix(0, nrow = length(lambdas), ncol = length(etas), 
                 dimnames = list(lambdas, etas))
  
  for (i in seq(length(lambdas))) {
    for (j in seq(length(etas))){
      mat <- lapply(folds, function(x) x[[i]][[j]])
      mat <- do.call(rbind, mat)
      if (all(is.finite(mat))) {
        if (criterion == "stability") {
          pearson_cor = cor(t(mat))
          grid[i,j] <- mean(pearson_cor[lower.tri(pearson_cor)], na.rm = TRUE)
        } else {
          grid[i,j] <- sum(colSums(mat)) / (10 * sum(colSums(mat) != 0))
        }
      } else {
        grid[i, j] <- -Inf
      }
    }
  }
  
  best <- which(grid == max(grid), arr.ind = TRUE)
  best_lambda <- lambdas[best[1, 'row']]
  best_eta <- etas[best[1, 'col']]
  
  message('Grid of ', criterion, ' scores (lambdas \u00D7 etas):\n')
  message(paste0(capture.output(grid), collapse = "\n") )
  message("Selected parameters:\neta =", best_eta, "\nlambda =", best_lambda)
  
  cones <- mincut(gwas, net, covars, best_eta, best_lambda, score, sigmod, 
                  family, link)
  
  return(cones)
  
}

#' Find connected explanatory SNPs
#' 
#' @description Finds the SNPs maximally associated with a phenotype while being
#' connected in an underlying network.
#' @template params_gwas
#' @template params_net
#' @template params_net
#' @template params_eta
#' @template params_lambda
#' @template params_covars
#' @template params_score
#' @template params_family
#' @template params_link
#' @template return_cones
#' @inherit scones.cv return references
#' @examples
#' gi <- get_GI_network(minigwas, snpMapping = minisnpMapping, ppi = minippi)
#' scones(minigwas, gi, 10, 1)
#' @export
scones <- function(gwas, net, eta, lambda, covars = data.frame(), 
                   score = c("chi2", "glm", "r2"), 
                   family = c("binomial", "poisson", "gaussian", "gamma"), 
                   link = c("logit", "log", "identity", "inverse")) {
  
  score <- match.arg(score)
  family <- match.arg(family)
  link <- match.arg(link)
  
  return(mincut(gwas, net, covars, eta, lambda, score, FALSE, family, link))
  
}

#' Run min-cut algorithm
#'
#' @template return_cones
#' @keywords internal
mincut <- function(gwas, net, covars, eta, lambda, score, sigmod, family, link){
  
  A <- get_adjacency(gwas, net)
  
  covars <- arrange_covars(gwas, covars)
  
  map <- sanitize_map(gwas)
  c <- snp_test(gwas, covars, score, family, link)
  c <- if (sigmod) c + lambda * rowSums(A) else c
  selected <- mincut_c(c, eta, lambda, A)
  cones <- induced_subgraph(net, map[['snp']][selected])
  
  
  return(cones)
  
}

#' Calculate genotype-phhenotype associations 
#' 
#' @description Calculate the association between genotypes and a phenotype,
#' adjusting by covariates.
#' @template params_gwas
#' @template params_covars
#' @template params_score
#' @template params_family
#' @template params_link
#' @return A named vector with the association scores.
#' @importFrom snpStats single.snp.tests chi.squared snp.rhs.tests
#' @importFrom stats t.test
#' @keywords internal
snp_test <- function(gwas, covars, score, family, link) {
  
  genotypes <- gwas[['genotypes']]
  phenotypes <- gwas[['fam']][['affected']]
  
  if (score == 'chi2') {
    
    tests <- single.snp.tests(phenotypes, snp.data = genotypes)
    c <- chi.squared(tests, df=1)
    
  } else if (score == 'glm') {
    
    if (ncol(covars) && nrow(covars) == nrow(genotypes)) {
      covars <- as.matrix(covars)
      tests <- snp.rhs.tests(phenotypes ~ covars, snp.data = genotypes,
                             family = family, link = link)
    } else {
      tests <- snp.rhs.tests(phenotypes ~ 1, snp.data = genotypes,
                             family = family, link = link)
    }
    
    c <- chi.squared(tests)
    names(c) <- names(tests)
  } else if (score == 'r2') {
    
    c <- apply(genotypes, 2, cor, phenotypes, use="pairwise.complete.obs")
    c[is.na(c)] <- 0.01
    c <- c^2
    
  }
  
  c[is.na(c)] <- 0
  
  return(c)
}

#' Score the solutions of a k-fold
#' 
#' @description Take the k-solutions for a combination of hyperparameters, and 
#' assign a score to it (the larger, the better).
#' @template params_gwas
#' @template params_net
#' @template params_covars
#' @template params_criterion
#' @template params_max_prop_snp
#' @importFrom igraph induced_subgraph transitivity
#' @importFrom methods as
#' @importFrom stats glm BIC AIC
#' @keywords internal
score_fold <- function(gwas, covars, net, selected, criterion, max_prop_snp) {
  
  # score for a trivial solution
  score <- -Inf
  
  if (sum(selected) & (sum(selected) / length(selected) <= max_prop_snp) ){
    if (criterion == 'stability') {
      score <- selected
    } else if (criterion %in% c('bic', 'aic', 'aicc')) {
      
      phenotypes <- gwas[['fam']][['affected']]
      genotypes <- as(gwas[['genotypes']], 'numeric')
      genotypes <- as.data.frame(genotypes[, selected])
      if (ncol(covars)) {
        covars <- arrange_covars(gwas, covars)
        genotypes <- cbind(genotypes, covars)
      }
      
      model <- glm(phenotypes ~ ., data = genotypes)
      
      if (criterion == 'bic') {
        score <- BIC(model)
      } else if (criterion == 'aic') {
        score <- AIC(model)
      } else if (criterion == 'aicc') {
        k <- ncol(genotypes)
        n <- nrow(genotypes)
        score <- AIC(model) + (2*k^2 + 2*k)/(n - k - 1)
      }
      # invert scores, as best models have the lowest scores
      score <- -score
    } else if (criterion %in% c('local_clustering', 'global_clustering')) {
      cones <- sanitize_map(gwas)
      cones <- cones[selected, 'snp']
      cones_subnet <- induced_subgraph(net, cones)
      
      if (criterion == 'local_clustering') {
        score <- transitivity(cones_subnet, type = 'local')
        score <- mean(score, na.rm = TRUE)
      } else if (criterion == 'global_clustering') {
        score <- transitivity(cones_subnet, type = 'global')
      }
    }
  }
  
  return(score)
  
}

#' Parse \code{scones.cv} settings
#' 
#' @description Creates a list composed by all \code{scones.cv} settings, with 
#' the values provided by the user, or the default ones if none is provided.
#' @template params_c
#' @template params_etas
#' @template params_lambdas
#' @return A list of \code{scones.cv} settings.
#' @importFrom stats quantile
#' @examples 
#' martini:::get_grid(etas = c(1,2,3), lambdas = c(4,5,6))
#' martini:::get_grid(c = c(1,10,100))
#' @keywords internal
get_grid <- function(c = numeric(), etas = numeric(), lambdas = numeric()) {
  
  grid <- list()
  
  if (length(c)) {
    # remove lowest c, which pull the grid towards irrelevant values
    maxc <- log10(max(c))
    ## add noise to avoid issues with repeated cs
    c <- c + abs(rnorm(length(c), sd = 1e-10))
    c <- c[c > quantile(c, 0.01)]
    minc <- log10(min(c))
  }
  
  if (length(etas) & is.numeric(etas)) {
    grid[['etas']] <- sort(etas)
  } else if (length(c)) {
    grid[['etas']] <- 10^seq(minc, maxc, length=10)
    grid[['etas']] <- signif(grid[['etas']], 3)
  } else {
    stop("Error: specify a valid etas or an association vector.")
  }
  
  if (length(lambdas) & is.numeric(lambdas)) {
    grid[['lambdas']] <- sort(lambdas)
  } else if (length(c)) {
    grid[['lambdas']] <- 10^seq(minc - 1, maxc + 1, length=10)
    grid[['lambdas']] <- signif(grid[['lambdas']], 3)
  } else {
    stop("Error: specify a valid lambdas or an association vector.")
  }
  
  return(grid)
  
}

test_that("output is as expected", {
  
  cones <- scones(test_gwas, test_gi, 10, 1)
  cones.cv <- scones.cv(test_gwas, test_gi)
  
  expect_true(all(V(cones) == V(cones.cv)))
  expect_true(all(E(cones) == E(cones.cv)))
  
})

library(martini)

set.seed(0)

test_that("default args are being set", {
  expect_equal(get_grid(c = c(0,1))$etas, rep(1, 10))
  expect_equal(get_grid(c = c(0,1))$lambdas, 
              10^seq(-1, 1, length.out = 10), tolerance=0.01)
})

test_that("default we can change values", {
  expect_equal(get_grid(c = c(0,1), etas = c(3,4,5))$etas, c(3,4,5))
  expect_error(get_grid(etas = c("a","b"))$etas)
  expect_equal(get_grid(c = c(0,1), lambdas = c(3,4,5))$lambdas, c(3,4,5))
  expect_error(get_grid(etas = c(1,2,3), lambdas = c("a","b")),
               'specify a valid lambdas or an association vector.')
  expect_error(get_grid(etas = c("a","b"), lambdas = c(1,2,3)),
               'specify a valid etas or an association vector.')
  expect_error(get_grid(c = c(0,1), debug = 3))
})

test_that("chi2 are correctly calculated", {
  
  true_vals <- c(98, 98, 97, 99, 97, 96, 0, 1, 1, 1, 1, 0, 
                 0, 0, 99, 99, 97, 98, 98, 99, 0, 1, 0, 1, 0)
  names(true_vals) <- test_gwas[['map']][['snp.name']]
  c <- snp_test(test_gwas, covars, 'chi2')
  
  expect_equal(c, true_vals, tolerance = .1)
  
  # covariates have no effect
  c <- snp_test(test_gwas, data.frame(), 'chi2')
  expect_equal(c, true_vals, tolerance = .1)
  
})

test_that("glm's chi2 are correctly calculated", {
  
  # without covariates
  true_vals <- c(99, 99, 98, 100, 98, 97, 0, 1, 1, 1, 1, 0, 0, 
                 0, 100, 100, 98, 99, 99, 100, 0.3, 1, 0, 1, 0)
  names(true_vals) <- test_gwas[['map']][['snp.name']]
  
  c <- snp_test(test_gwas, data.frame(), 'glm', "binomial", "logit")
  
  expect_equal(c, true_vals, tolerance = .1)
  
  # with explanatory covariates
  true_vals <- rep(0, nrow(test_gwas[['map']]))
  names(true_vals) <- test_gwas[['map']][['snp.name']]
  c <- snp_test(test_gwas, covars, 'glm', "binomial", "logit")
  
  expect_equal(c, true_vals, tolerance = .1)
  
})

test_that("linear model is correctly calculated", {
  
  # without covariates
  true_vals <- c(99, 99, 98, 100, 98, 97, 0, 1, 1, 1, 1, 0, 0, 
                 0, 100, 100, 98, 99, 99, 100, 0.3, 1, 0, 1, 0)
  names(true_vals) <- test_gwas[['map']][['snp.name']]
  
  c <- snp_test(test_gwas, data.frame(), 'glm', "Gaussian", "identity")
  
  expect_equal(c, true_vals, tolerance = .1)
  
})

K <- cut(seq(1, nrow(test_gwas[['fam']])), breaks = 2, labels = FALSE)

test_that("stability works", {
  
  criterion <- 'stability'
  max_prop_snp <- 0.5
  
  selected <- c(TRUE,TRUE,TRUE,TRUE,TRUE,FALSE,FALSE,FALSE,FALSE,FALSE)
  expect_equal(selected, martini:::score_fold(test_gwas, data.frame(), gi, selected, criterion, max_prop_snp))
  
})

test_that("clustering coefficients works", {
  
  # test edge cases 
  full_graph <- make_full_graph(10)
  test_graph <- full_graph + graph_from_edgelist(cbind(seq(1, 14), seq(2, 15)), directed = FALSE)
  V(test_graph)$name <- test_gwas[['map']][['snp.name']]
  
  selected <- c(rep(TRUE, 10), rep(FALSE, 15))
  expect_equal(1, martini:::score_fold(test_gwas, data.frame(), test_graph, selected, 'global_clustering', 0.5))
  expect_equal(1, martini:::score_fold(test_gwas, data.frame(), test_graph, selected, 'local_clustering', 0.5))
  
  selected <- c(rep(FALSE, 15), rep(TRUE, 10))
  expect_equal(0, martini:::score_fold(test_gwas, data.frame(), test_graph, selected, 'global_clustering', 0.5))
  expect_equal(0, martini:::score_fold(test_gwas, data.frame(), test_graph, selected, 'local_clustering', 0.5))
  
})

test_that('log-penalized functions work', {
  
  selected <- c(TRUE,TRUE,TRUE,TRUE,TRUE,FALSE,FALSE,FALSE,FALSE,FALSE)
  phenotypes <- test_gwas[['fam']][['affected']]
  genotypes <- as(test_gwas[['genotypes']], 'numeric')
  genotypes <- as.data.frame(genotypes[, selected])
  genotypes <- cbind(genotypes, covars[,c('confounding','unrelated')])
  
  k <- ncol(genotypes)
  n <- nrow(genotypes)
  
  set.seed(0)
  model <- glm(phenotypes ~ ., data = genotypes)
  expect_equal(gsub('`', '', names(coefficients(model))), 
               c("(Intercept)", colnames(genotypes)))
  
  set.seed(0)
  expect_equal(-BIC(model), martini:::score_fold(test_gwas, covars, gi, selected, 'bic', 0.5), tolerance = 4)
  expect_equal(-AIC(model), martini:::score_fold(test_gwas, covars, gi, selected, 'aic', 0.5), tolerance = 4)
  expect_equal(-(AIC(model) + (2*k^2 + 2*k)/(n-k-1)), 
               martini:::score_fold(test_gwas, covars, gi, selected, 'aicc', 0.5), tolerance = 4)
  
})

minimum_gwas <- list()
minimum_gwas$map <- read.table(text = "
                       chr snp.name cm gpos allele.1 allele.2
                       1 rs1 0 10 A G
                       1 rs2 0 20 A G
                       1 rs3 0 30 A G
                       2 rs4 0 15 A G
                       2 rs5 0 25 A G
                       2 rs6 0 35 A G
                       2 rs7 0 45 A G
                       2 rs8 0 55 A G
                       2 rs9 0 65 A G
                       2 rs10 0 75 A G
                       2 rs11 0 85 A G
                       ", header = TRUE, stringsAsFactors = FALSE)

snpMapping <- read.table(text = "
                       snp gene
                       rs1 A
                       rs2 A
                       rs5 B
                       rs6 B
                       rs8 C
                       rs9 C
                       rs10 D
                       rs11 C
                       rs11 D
                       ", header = TRUE, stringsAsFactors = FALSE)
ppi <- read.table(text = "
                  gene1 gene2
                  A B
                  A C
                  B D
                  ", header = TRUE, stringsAsFactors = FALSE)

mini_gs <- get_GS_network(minimum_gwas)
mini_gm <- get_GM_network(minimum_gwas, snpMapping = snpMapping)
mini_gi <- get_GI_network(minimum_gwas, snpMapping = snpMapping, ppi = ppi)

result <- read.table(text = "
                       chr snp.name cm gpos allele.1 allele.2 selected C module
                       1 rs1 0 10 A G TRUE 100 1
                       1 rs2 0 20 A G FALSE 10 NA
                       1 rs3 0 30 A G FALSE 10 NA
                       2 rs4 0 15 A G FALSE 10 NA
                       2 rs5 0 25 A G FALSE 10 NA
                       2 rs6 0 35 A G TRUE 100 1
                       ", header = TRUE, stringsAsFactors = FALSE)

# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

#' Maxflow algorithm
#' 
#' @description Run the maxflow algorithm.
#' @param A A sparse matrix with the connectivity.
#' @param As A vector containing the edges to the source.
#' @param At A vector containing the edges to the sink.
#' @return A list with vector indicating if the feature was selected and the 
#' objective score.
maxflow <- function(A, As, At) {
    .Call('_martini_maxflow', PACKAGE = 'martini', A, As, At)
}

#' Min-cut algorithm
#' 
#' @description Run the mincut algorithm.
#' @param c A vector with the association of each SNP with the phenotype.
#' @param eta A numeric with the value of the eta parameter.
#' @param lambda A numeric with the value of the eta parameter.
#' @param W A sparse matrix with the connectivity.
#' @return A list with vector indicating if the feature was selected and the 
#' objective score.
mincut_c <- function(c, eta, lambda, W) {
    .Call('_martini_mincut_c', PACKAGE = 'martini', c, eta, lambda, W)
}

# Register entry points for exported C++ functions
methods::setLoadAction(function(ns) {
    .Call('_martini_RcppExport_registerCCallable', PACKAGE = 'martini')
})

library(martini)

test_that("output is as expected", {
  
  c <- rep(1, 3)
  W <- matrix(c(0,1,0,1,0,1,0,1,0,0,0,1), 3, 3)
  W <- as(W, Class = "dgCMatrix")
  
  selected <- mincut_c(c, 1, 2, W)
  
  expect_equal(length(selected), 3)
  expect_equal(class(selected), "logical")

})

test_that("we recover causal SNPs", {
  
  pCausal <- 20
  pNonCausal <- 100
  
  c <- c(rep(10, pCausal), rep(0,pNonCausal))
  
  W <- diag(1, pCausal + pNonCausal, pCausal + pNonCausal)
  W <- cbind(rbind(0, W[-1,-1]),0) + rbind(cbind(0,W[-1,-1]),0)
  W[1:pCausal, 1:pCausal] <- 1
  diag(W) <- 0
  W <- as(W, Class = "dgCMatrix")
  
  selected <- mincut_c(c, 1, 2, W)
  
  expect_equal(sum(selected), pCausal)
  expect_true(all(as.logical(selected[1:pCausal])))
  
})

test_that("we connect the consecutive SNPs", {
  expect_true(igraph::are_adjacent(mini_gs, "rs1", "rs2"))
  expect_true(igraph::are_adjacent(mini_gs, "rs2", "rs3"))
  expect_false(igraph::are_adjacent(mini_gs, "rs3", "rs4"))
})

test_that("we add genomic information to the vertices", {
  expect_equal(igraph::get.vertex.attribute(mini_gs, "chr", match(c("rs1", "rs2", "rs3"), igraph::V(mini_gs)$name) ), rep(1, 3) )
  expect_equal(igraph::get.vertex.attribute(mini_gs, "chr", match(c("rs4", "rs5", "rs6"), igraph::V(mini_gs)$name) ), rep(2, 3) )
  expect_equal(igraph::get.vertex.attribute(mini_gs, "pos", match(c("rs1", "rs2", "rs3"), igraph::V(mini_gs)$name) ), c(10, 20, 30) )
  expect_equal(igraph::get.vertex.attribute(mini_gs, "pos", match(c("rs4", "rs5", "rs6"), igraph::V(mini_gs)$name) ), c(15, 25, 35) )
})

test_that("edges have weights", {
  expect_false(is.null(igraph::E(mini_gs)$weight))
})

---
title: "Running SConES"
author: "Héctor Climente-González"
date: "`r Sys.Date()`"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Running SConES}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
bibliography: bibliography.bib
---

In this example we will analyze a simple case of GWAS data. We start by loading the `martini`, which contains the example we will work on.

```{r load martini}
library(martini)
```

# Experimental data

`minigwas` is a simplification of an actual GWAS. It is a list equivalent to what `snpStats::read.pedfile` would generate. In this experiment, we sequenced 25 SNPs on 100 samples. Half of them suffer from a disease, the other half are perfectly healthy individuals. The information of each patient is available in the `fam` element:

```{r print fam}
head(minigwas$fam)
```

We pay close attention to the `affected` column, with takes value `2` if the patient is a case, or `1` if they are control. 

The other important element is `map`, which contains the SNP information:

```{r print map}
head(minigwas$map)
```

In `minigwas`, the SNP name is a three character word, where every letter has a meaning: the first character indicates the chromosome, the second the gene, and the third its position inside the gene. 

Lastly, `genotypes` contains the actual genotype for each SNP and sample.

```{r print genotypes}
minigwas$genotypes
```

# The network

Other than the information from the GWAS experiment, we need a network of SNPs to work on. We can create those described in [@Azencott2013] with the family of `get_G*_network` functions. Let's see how they work.

```{r create GS network}
gs <- get_GS_network(minigwas)
par(mar=c(0,0,0,0)+.1)
plot(gs)
```

The GS network contains information about the genomic structure: it is created by connecting every SNP to the adjacent one. The result are one linear subgraph for each chromosome. Hence, GS network contains spacial information about the SNPs, which might be useful in investigating genotypes were a chromosomic region has been related to a disease.

```{r create GM network}
gm <- get_GM_network(minigwas, snpMapping = minisnpMapping)
par(mar=c(0,0,0,0)+.1)
plot(gm)
```

The GM network builds on the GS network, additionally interconnecting all SNPs belonging to the same gene. Still, each chromosome has its independent subnetwork. GM network gives insights into the functionality implications, as it will interconnect causal SNPs that belong to the same gene (which were already close in the GS network).

```{r create GI network}
gi <- get_GI_network(minigwas, snpMapping = minisnpMapping, ppi = minippi)
par(mar=c(0,0,0,0)+.1)
plot(gi)
```

The GI network builds on the GM network by connecting SNPs belonging to genes interacting with each other, for example, through a protein-protein interaction of their products. This kind of network contains, but it is not limited to, pathway information and crosstalk.

# Running SConES

Once we have the network, we can find ConES (connected explanatory SNPs), the set of SNPs $S$ that solve the problem

$$argmax_{S \subseteq V} \sum_{p \in S} c_p - \sum_{p \in S} \eta - \sum_{p \in S} \sum_{q \notin S} \lambda W_{pq} .$$
where $c$ represents an association measure with the phenotype (e.g. $\chi^2_1$) and $W_{pq}$ is the weight of the edge between $p$ and $q$. $\eta$ and $\lambda$ are parameters that enforce sparsity and connectivity on the subset respectively. Essentially, we are looking for a small subset of SNPs maximally associated with the phenotype that is mostly interconnected among itself in the network. 

We can find ConES in `martini` with the function `scones`, which implements SConES [@Azencott2013]. By default, it takes a GWAS experiment and a SNP network, uses $\chi^2_1$ as association measure and performs a grid search over $\eta$ and $\lambda$ to find the combination that results in the best BIC.

```{r find cones gridsearch}
cones <- scones.cv(minigwas, gi)
```
`scones` informs us of the optimal values for $\eta$ and $\lambda$. The results is a data frame that looks like this:

```{r}
head(cones)
```

The first six columns of the data frame come from the `map` data frame. The remaining represent the output of SConES:

- `c` contains the SNP univariate association score.
- `selected` is a logical vector indicating wether a SNP has been selected or not.
- `module` is an id shared by all the SNPs included in the same submodule of the solution subnetwork. They are not necesarily connected to each other, but there must be a path connecting them inside the solution subnetwork.

# References

---
title: "Simulating SConES-based phenotypes"
author: "Héctor Climente-González"
date: "`r Sys.Date()`"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Simulating SConES-based phenotypes}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
bibliography: bibliography.bib
---

This example will illustrate how to simulate phenotypes that are based on the premises of SConES: they are caused by SNPs interconnected in the underlying network. The simulation has two steps: 1) simulating the causal mechanism and 2) simulating the phenotypes.

We will start by loading `martini`.

```{r load_martini}
library(martini)
```

Before starting, we need to create a network over which we will act.

```{r create_gi}
gi <- get_GI_network(minigwas, snpMapping = minisnpMapping, ppi = minippi)
```

This is a really simple network, formed by only 4 genes. Of these, we will randomly select 2 of them, interconnected in the network, and 30% of their SNPs will be causal.

```{r simulate_snps}
causal <- simulate_causal_snps(gi, ngenes = 2, pcausal = 0.3)

par(mar=c(0,0,0,0)+.1)
plot(gi, mark.groups = names(causal))
```

The selected SNPs are highlighted. As we can see, they match the conditions described before i.e. they are mapped to a gene and are interconnected in the underlying network. Here are some examples of causal mechanisms that are simulated in the human interactome-derived GI network.

![](example_causal_subnetworks.png)

This SNPs can be directly passed to `simulate_phenotypes()` in order to simulate a phenotype based on the genotypes on these SNPs on an existing experiment. It starts from an existing GWAS experiment, in order to mantain the linkage disequilibrium patterns, the complexity of the network, etc. of a real case. If the existing GWAS experiment is a case-control, only the controls are used for the simulation.

A quantitative phenotype $y_j$ is simulated for a patient $j$ using the following additive model, proposed in [@Yang2011]:

$$ y_j = \sum\nolimits_i w_{ij} u_i + e_j $$

where the weight $w_{ij}$ is the inclination of the genotype $i$ of patient $j$ over the phenotype; the allelic effect of the $i$-th causal variant $u_i$ in arbitrary units; and the residual effect $e_j$ is the the proportion of the trait not attributable to the genotype. 

The weight $w_{ij}$ is calculated as

$$ w_{ij} = \frac{x_{ij} - 2p_i}{\sqrt{2p_i(1 - p_i)}} $$

where $x_{ij}$ is the number of reference alleles for the $i$-th causal variant of the $j$-th individual; and $p_i$ is the frequency of the $i$-th causal variant. $w_{ij}$ follows a sigmoid like behavior for different $p$: the rarer an allele is, the stronger its impact on the phenotype.

The most interesting bit of this simulation, however, has to do with the residual effect $e_j$, given that it depends directly on the heritability of the trait. $e_j$ is generated from a normal distribution with mean of 0 and variance 

$$ \frac{1}{h^2 - 1} var(\sum\nolimits_i w_{ij} u_i)$$

When all variance is due to genetics ($h^2 = 1$), $e_j = 0$ for every patient $j$.

Our limited `minigwas` is too homogeneous to perform any simulation, so we will first randomly simulate a genotype matrix. Then, we will simualte a phenotype assuming a heritability $h^2=0.9$:

```{r simulate_quantitative_phenotype}
# create a random 100x25 matrix of genotypes
X <- lapply(seq_len(100), function(i) { sample(c(0,1,2), 25, replace = TRUE) })
X <- do.call(rbind, X)

colnames(X) <- minigwas$map$snp.name
rownames(X) <- 1:nrow(X)

X <- X + 1
mode(X) <- "raw"
minigwas$genotypes <- new("SnpMatrix", X)

simulated <- simulate_phenotype(minigwas, snps = causal, h2 = 0.9)
```

`simulate_phenotypes()` returns an object identical to the input GWAS, where the phenotype has been replace by the simulation. Case-control phenotypes are also possible. It is created by dividing in two the aforementioned distribution $y$ into cases and controls. In this case, $y$ reflects the general population, and the number of cases cannot represent a higher proportion than a specified prevalence of the disease.

```{r simulate_qualitative_phenotype}
simulated <- simulate_phenotype(minigwas, snps = causal, h2 = 0.9, qualitative = TRUE,
                                ncases = 10, ncontrols = 40, prevalence = 0.2)
```

# References

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/db.R
\name{get_gxg_biogrid}
\alias{get_gxg_biogrid}
\title{Get BioGRID protein-protein interactions.}
\usage{
get_gxg_biogrid(organism = 9606)
}
\arguments{
\item{organism}{Tax ID of the studied organism. The default is 9606 (human).}
}
\value{
A data.frame with two columns with pairs of interacting proteins.
}
\description{
Get all protein-protein interactions for an organism from
BioGRID.
}
\examples{
# download dog interactions
\dontrun{martini:::get_gxg_biogrid(9615)}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{subvert}
\alias{subvert}
\title{Vertices with an attribute}
\usage{
subvert(net, attr, values, affirmative = TRUE)
}
\arguments{
\item{net}{An igraph network.}

\item{attr}{An attribute of the vertices.}

\item{values}{Possible values of \code{attr}}

\item{affirmative}{Logical. States if a condition must be its affirmation 
(e.g. all nodes with gene name "X"), or its negation (all nodes not with gene
name "X").}
}
\value{
The vertices with attribute equal to any of the values in
\code{values}.
}
\description{
Returns the nodes matching some condition.
}
\examples{
gi <- get_GI_network(minigwas, snpMapping = minisnpMapping, ppi = minippi)
martini:::subvert(gi, "gene", "A")
martini:::subvert(gi, "name", c("1A1", "1A3"))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simulation.R
\name{calculateE}
\alias{calculateE}
\title{Calculate the environmental component of the phenotype}
\usage{
calculateE(G, h2)
}
\arguments{
\item{G}{The genetic component of the phenotype.}

\item{h2}{The heritability.}
}
\value{
A vector with the environmental component of each sample.
}
\description{
Calculates the environmental component of the phenotype using
the variance in the genetic component.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/datasets.R
\docType{data}
\name{minippi}
\alias{minippi}
\title{PPIs for the minigwas dataset.}
\description{
data.frame describing pairs of proteins that interact for 
minigwas.
}
\examples{
data(minippi)

head(minippi)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{organism_id2name}
\alias{organism_id2name}
\title{Tax id to ensembl species name}
\usage{
organism_id2name(id)
}
\arguments{
\item{organism}{Tax ID of the studied organism. The default is 9606 (human).}
}
\description{
Converts taxid to ensembl species name e.g. human databases are 
hsapiens_*
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{maxflow}
\alias{maxflow}
\title{Maxflow algorithm}
\usage{
maxflow(A, As, At)
}
\arguments{
\item{A}{A sparse matrix with the connectivity.}

\item{As}{A vector containing the edges to the source.}

\item{At}{A vector containing the edges to the sink.}
}
\value{
A list with vector indicating if the feature was selected and the 
objective score.
}
\description{
Run the maxflow algorithm.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{mincut_c}
\alias{mincut_c}
\title{Min-cut algorithm}
\usage{
mincut_c(c, eta, lambda, W)
}
\arguments{
\item{c}{A vector with the association of each SNP with the phenotype.}

\item{eta}{A numeric with the value of the eta parameter.}

\item{lambda}{A numeric with the value of the eta parameter.}

\item{W}{A sparse matrix with the connectivity.}
}
\value{
A list with vector indicating if the feature was selected and the 
objective score.
}
\description{
Run the mincut algorithm.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{permute_snpMatrix}
\alias{permute_snpMatrix}
\title{Permute samples}
\usage{
permute_snpMatrix(gwas)
}
\arguments{
\item{gwas}{A SnpMatrix object with the GWAS information.}
}
\description{
Compute a permutation of the samples of a snpMatrix object. 
Useful to make sure that the folds are not stratified by phenotype.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{subnet}
\alias{subnet}
\title{Subgraph of vertices with an attribute}
\usage{
subnet(net, attr, values, affirmative = TRUE)
}
\arguments{
\item{net}{An igraph network.}

\item{attr}{An attribute of the vertices.}

\item{values}{Possible values of \code{attr}.}

\item{affirmative}{Logical. States if a condition must be its affirmation 
(e.g. all nodes with gene name "X"), or its negation (all nodes not with gene
name "X").}
}
\value{
A subgraph containing only the vertices with attribute equal to any
of the values in \code{values}.
}
\description{
Returns a subgraph matching some condition.
}
\examples{
gi <- get_GI_network(minigwas, snpMapping = minisnpMapping, ppi = minippi)
martini:::subnet(gi, "gene", "A")
martini:::subnet(gi, "name", c("1A1", "1A3"))
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/viz.R
\name{plot_ideogram}
\alias{plot_ideogram}
\title{Ideogram of SConES results.}
\usage{
plot_ideogram(gwas, net, covars = data.frame(), genome = "hg19")
}
\arguments{
\item{gwas}{A SnpMatrix object with the GWAS information.}

\item{net}{An igraph network that connects the SNPs.}

\item{covars}{A data frame with the covariates. It must contain a column 
'sample' containing the sample IDs, and an additional columns for each 
covariate.}

\item{genome}{Abbreviations of the genome to use: hg19 for human (default), 
mm10 for mouse, etc.}
}
\value{
A circular ideogram, including the manhattan plot, and the
interactions between the selected SNPs.
}
\description{
Create a circular ideogram of the a network results using the
circlize package (Gu et al., 2014).
}
\references{
Gu, Z., Gu, L., Eils, R., Schlesner, M., & Brors, B. (2014).
circlize Implements and enhances circular visualization in R. Bioinformatics
(Oxford, England), 30(19), 2811-2. 
\url{https://doi.org/10.1093/bioinformatics/btu393}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{subset_snpMatrix}
\alias{subset_snpMatrix}
\title{Subsample snpMatrix}
\usage{
subset_snpMatrix(gwas, samples)
}
\arguments{
\item{gwas}{A SnpMatrix object with the GWAS information.}

\item{samples}{Vector (logical or numeric) containing the samples to select.}
}
\description{
Compute a permutation of the samples of a snpMatrix object. 
Useful to make sure that the folds are not stratified by phenotype.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scones.R
\name{score_fold}
\alias{score_fold}
\title{Score the solutions of a k-fold}
\usage{
score_fold(gwas, covars, net, selected, criterion, max_prop_snp)
}
\arguments{
\item{gwas}{A SnpMatrix object with the GWAS information.}

\item{covars}{A data frame with the covariates. It must contain a column 
'sample' containing the sample IDs, and an additional columns for each 
covariate.}

\item{net}{An igraph network that connects the SNPs.}

\item{criterion}{String with the function to measure the quality of a split.}

\item{max_prop_snp}{Maximum proportion of SNPs accepted in the model (between 0 and 1). Larger solutions will be discarded.}
}
\description{
Take the k-solutions for a combination of hyperparameters, and 
assign a score to it (the larger, the better).
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scones.R
\name{scones.cv}
\alias{scones.cv}
\title{Find connected explanatory SNPs.}
\usage{
scones.cv(
  gwas,
  net,
  covars = data.frame(),
  score = c("chi2", "glm", "r2"),
  criterion = c("stability", "bic", "aic", "aicc", "global_clustering",
    "local_clustering"),
  etas = numeric(),
  lambdas = numeric(),
  family = c("binomial", "poisson", "gaussian", "gamma"),
  link = c("logit", "log", "identity", "inverse"),
  max_prop_snp = 0.5
)
}
\arguments{
\item{gwas}{A SnpMatrix object with the GWAS information.}

\item{net}{An igraph network that connects the SNPs.}

\item{covars}{A data frame with the covariates. It must contain a column 
'sample' containing the sample IDs, and an additional columns for each 
covariate.}

\item{score}{Association score to measure association between genotype and 
phenotype. Possible values: chi2 (default), glm.}

\item{criterion}{String with the function to measure the quality of a split.}

\item{etas}{Numeric vector with the etas to explore in the grid search. If 
ommited, it's automatically created based on the association
scores.}

\item{lambdas}{Numeric vector with the lambdas to explore in the grid search.
If ommited, it's automatically created based on the association scores.}

\item{family}{A string defining the generalized linear model family. This 
should match one of "binomial", "poisson", "gaussian" or "gamma". See
\link[snpStats]{snp.rhs.tests} for details.}

\item{link}{A string defining the link function for the GLM. This should
match one of "logit", "log", "identity" or "inverse". See 
\link[snpStats]{snp.rhs.tests} for details.}

\item{max_prop_snp}{Maximum proportion of SNPs accepted in the model (between 0 and 1). Larger solutions will be discarded.}
}
\value{
A copy of the \code{SnpMatrix$map} \code{data.frame}, with the 
following additions:
\itemize{
\item{c: contains the univariate association score for every single SNP.}
\item{selected: logical vector indicating if the SNP was selected by SConES 
or not.}
\item{module: integer with the number of the module the SNP belongs to.}
}
}
\description{
Finds the SNPs maximally associated with a phenotype while being
connected in an underlying network. Select the hyperparameters by
cross-validation.
}
\examples{
gi <- get_GI_network(minigwas, snpMapping = minisnpMapping, ppi = minippi)
scones.cv(minigwas, gi)
scones.cv(minigwas, gi, score = "glm")
}
\references{
Azencott, C. A., Grimm, D., Sugiyama, M., Kawahara, Y., &
Borgwardt, K. M. (2013). Efficient network-guided multi-locus association
mapping with graph cuts. Bioinformatics, 29(13), 171-179.
\url{https://doi.org/10.1093/bioinformatics/btt238}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/db.R
\name{snp2ensembl}
\alias{snp2ensembl}
\title{Map SNPs to Ensembl genes.}
\usage{
snp2ensembl(gwas, organism = 9606, flank = 0)
}
\arguments{
\item{gwas}{A SnpMatrix object with the GWAS information.}

\item{organism}{Tax ID of the studied organism. The default is 9606 (human).}

\item{flank}{A number with the flanking regions around genes to be considered
part of the gene i.e. SNPs mapped to them will be considered mapped to the
gene.}
}
\value{
A data.frame with two columns: one for the SNP and another for the
gene it has been mapped to.
}
\description{
Maps SNPs from a GWAS experiment to genes.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scones.R
\name{mincut.cv}
\alias{mincut.cv}
\title{Run the cross-validated min-cut algorithm}
\usage{
mincut.cv(
  gwas,
  net,
  covars,
  etas,
  lambdas,
  criterion,
  score,
  sigmod,
  family,
  link,
  max_prop_snp
)
}
\arguments{
\item{gwas}{A SnpMatrix object with the GWAS information.}

\item{net}{An igraph network that connects the SNPs.}

\item{covars}{A data frame with the covariates. It must contain a column 
'sample' containing the sample IDs, and an additional columns for each 
covariate.}

\item{family}{A string defining the generalized linear model family. This 
should match one of "binomial", "poisson", "gaussian" or "gamma". See
\link[snpStats]{snp.rhs.tests} for details.}

\item{link}{A string defining the link function for the GLM. This should
match one of "logit", "log", "identity" or "inverse". See 
\link[snpStats]{snp.rhs.tests} for details.}
}
\description{
Run the cross-validated min-cut algorithm
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{gwas2bed}
\alias{gwas2bed}
\title{Converts a MAP data.frame to a BED data.frame}
\usage{
gwas2bed(gwas)
}
\arguments{
\item{gwas}{A SnpMatrix object with the GWAS information.}
}
\value{
A BED data.frame.
}
\description{
Takes a map file and:
\itemize{
\item{column 1: Used as the chromosome column in the BED file.}
\item{column 4: Used as start and end in the BED data.frame (as we work with
SNPs).}
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{sanitize_map}
\alias{sanitize_map}
\title{Check map}
\usage{
sanitize_map(gwas)
}
\arguments{
\item{gwas}{A SnpMatrix object with the GWAS information.}
}
\description{
Check that map is a proper data.frame.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{is_coherent}
\alias{is_coherent}
\title{Check inner coherence of GWAS dataset}
\usage{
is_coherent(gwas)
}
\arguments{
\item{gwas}{A SnpMatrix object with the GWAS information.}
}
\value{
TRUE if the GWAS dataset is coherent. Else, raises an error.
}
\description{
Checks that the different data structures have the SNPs in the 
same order.
}
\examples{
martini:::is_coherent(minigwas)
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/datasets.R
\docType{data}
\name{minigwas}
\alias{minigwas}
\title{Description of the minigwas dataset.}
\format{
A list with 3 items:
\describe{
  \item{genotypes}{Genotype and phenotype information.}
  \item{fam}{Simulated network.}
  \item{map}{Result of runing \code{find_cones} with gwas and net.}
}
}
\description{
Small GWAS example.
}
\examples{
data(minigwas)

# access different elements
minigwas[["genotypes"]]
minigwas[["map"]]
minigwas[["fam"]]
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{arrange_covars}
\alias{arrange_covars}
\title{Prepare covariates for \code{scones}}
\usage{
arrange_covars(gwas, covars)
}
\arguments{
\item{gwas}{A SnpMatrix object with the GWAS information.}

\item{covars}{A data frame with the covariates. It must contain a column 
'sample' containing the sample IDs, and an additional columns for each 
covariate.}
}
\value{
The covars data.frame, with the rows in the same order as gwas.
}
\description{
Prepares de covariates data.frame for the functions used in
\code{scones}, like \code{single_snp_association} or \code{score_folds}
.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/db.R
\name{get_gxg}
\alias{get_gxg}
\title{Get gene interactions}
\usage{
get_gxg(db, organism, flush)
}
\arguments{
\item{db}{String containing the database to obtain the gene-gene interactions
from. Possible values: 'biogrid', 'string'.}

\item{organism}{Tax ID of the studied organism. The default is 9606 (human).}

\item{flush}{Remove cached results? Boolean value.}
}
\value{
A data.frame with two columns with pairs of interacting proteins.
}
\description{
Wrapper for the different functions to get gene-gene 
interactions. Supports cached results.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ld.R
\name{ldweight_edges}
\alias{ldweight_edges}
\title{Include linkage disequilibrium information in the network.}
\usage{
ldweight_edges(net, ld, method = "inverse")
}
\arguments{
\item{net}{A SNP network.}

\item{ld}{A \code{dsCMatrix} or \code{dgCMatrix} containing linkage 
disequilibrium measures, like the output of \code{\link[snpStats]{ld}}.}

\item{method}{How to incorporate linkage-disequilibrium values into the 
network.}
}
\value{
An copy of net where the edges weighted according to linkage 
disequilibrium.
}
\description{
Include linkage disequilibrium information in the SNP network. 
The weight of the edges will be lower the higher the linkage is.
}
\examples{
ld <- snpStats::ld(minigwas[['genotypes']], depth = 2, stats = "R.squared")
# don't weight edges for which LD cannot be calculated
ld[is.na(ld)] <- 0
gi <- get_GI_network(minigwas, snpMapping = minisnpMapping, ppi = minippi)
ldGi <- ldweight_edges(gi, ld)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sigmod.R
\name{sigmod}
\alias{sigmod}
\title{Find connected explanatory SNPs}
\usage{
sigmod(
  gwas,
  net,
  eta,
  lambda,
  covars = data.frame(),
  score = c("chi2", "glm", "r2"),
  family = c("binomial", "poisson", "gaussian", "gamma"),
  link = c("logit", "log", "identity", "inverse")
)
}
\arguments{
\item{gwas}{A SnpMatrix object with the GWAS information.}

\item{net}{An igraph network that connects the SNPs.}

\item{eta}{Value of the eta parameter.}

\item{lambda}{Value of the lambda parameter.}

\item{covars}{A data frame with the covariates. It must contain a column 
'sample' containing the sample IDs, and an additional columns for each 
covariate.}

\item{score}{Association score to measure association between genotype and 
phenotype. Possible values: chi2 (default), glm.}

\item{family}{A string defining the generalized linear model family. This 
should match one of "binomial", "poisson", "gaussian" or "gamma". See
\link[snpStats]{snp.rhs.tests} for details.}

\item{link}{A string defining the link function for the GLM. This should
match one of "logit", "log", "identity" or "inverse". See 
\link[snpStats]{snp.rhs.tests} for details.}
}
\value{
A copy of the \code{SnpMatrix$map} \code{data.frame}, with the 
following additions:
\itemize{
\item{c: contains the univariate association score for every single SNP.}
\item{selected: logical vector indicating if the SNP was selected by SConES 
or not.}
\item{module: integer with the number of the module the SNP belongs to.}
}
}
\description{
Finds the SNPs maximally associated with a phenotype while being
connected in an underlying network.
}
\examples{
gi <- get_GI_network(minigwas, snpMapping = minisnpMapping, ppi = minippi)
sigmod(minigwas, gi, 10, 1)
}
\references{
Liu, Y., Brossard, M., Roqueiro, D., Margaritte-Jeannin, P., 
Sarnowski, C., Bouzigon, E., Demenais, F. (2017). SigMod: an exact and
efficient method to identify a strongly interconnected disease-associated
module in a gene network. Bioinformatics, 33(10), 1536–1544. 
\url{https://doi.org/10.1093/bioinformatics/btx004}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/networks.R
\name{get_GM_network}
\alias{get_GM_network}
\title{Get gene membership network.}
\usage{
get_GM_network(
  gwas,
  organism = 9606,
  snpMapping = snp2ensembl(gwas, organism),
  col_genes = c("snp", "gene")
)
}
\arguments{
\item{gwas}{A SnpMatrix object with the GWAS information.}

\item{organism}{Tax ID of the studied organism. The default is 9606 (human).}

\item{snpMapping}{A data.frame informing how SNPs map to genes. It contains 
minimum two columns: SNP id and a gene it maps to. Each row corresponds to 
one gene-SNP mapping. Unless column names are specified using 
\code{col_genes}, involved columns must be named \code{'snp'} and 
\code{'gene'}.}

\item{col_genes}{Optional, length-2 character vector with the names of the 
two columns involving the SNP-gene mapping. The first element is the column 
of the SNP, and the second is the column of the gene.}
}
\value{
An igraph network of the GM network of the SNPs.
}
\description{
Creates a network of SNPs where each SNP is connected as in the
\link[=get_GS_network]{GS} network and, in addition, to all the other SNPs 
pertaining to the same gene. Corresponds to the gene membership (GM) network 
described by Azencott et al.
}
\examples{
get_GM_network(minigwas, snpMapping = minisnpMapping)
}
\references{
Azencott, C. A., Grimm, D., Sugiyama, M., Kawahara, Y., &
Borgwardt, K. M. (2013). Efficient network-guided multi-locus association
mapping with graph cuts. Bioinformatics, 29(13), 171-179.
\url{https://doi.org/10.1093/bioinformatics/btt238}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/nongwas.R
\name{wrap_Xy}
\alias{wrap_Xy}
\title{Make pseudo SnpMatrix object}
\usage{
wrap_Xy(X, y, featnames, net)
}
\arguments{
\item{X}{n x d design matrix}

\item{y}{Vector of length n with the outcomes}

\item{featnames}{Vector of length d with the feature names}

\item{net}{An igraph network that connects the SNPs.}
}
\description{
Wrap design matrix and outcome vector into a pseudo SnpMatrix
object.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scones.R
\name{mincut}
\alias{mincut}
\title{Run min-cut algorithm}
\usage{
mincut(gwas, net, covars, eta, lambda, score, sigmod, family, link)
}
\value{
A copy of the \code{SnpMatrix$map} \code{data.frame}, with the 
following additions:
\itemize{
\item{c: contains the univariate association score for every single SNP.}
\item{selected: logical vector indicating if the SNP was selected by SConES 
or not.}
\item{module: integer with the number of the module the SNP belongs to.}
}
}
\description{
Run min-cut algorithm
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{get_adjacency}
\alias{get_adjacency}
\title{Compute Laplacian matrix}
\usage{
get_adjacency(gwas, net)
}
\arguments{
\item{gwas}{A SnpMatrix object with the GWAS information.}

\item{net}{An igraph network that connects the SNPs.}
}
\value{
A Laplacian matrix.
}
\description{
Compute Laplacian matrix
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{check_installed}
\alias{check_installed}
\title{Check package is installed}
\usage{
check_installed(pkgs, fn = "This function")
}
\arguments{
\item{pkgs}{Character vector with the names of the packages.}

\item{fn}{Function calling the check.}
}
\value{
The package is loaded into the namespace.
}
\description{
Checks if a package is installed, launches an error if it is
not.
}
\examples{
martini:::check_installed(c("martini"))
\dontrun{martini:::check_installed("martinid")}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simulation.R
\name{simulate_causal_snps}
\alias{simulate_causal_snps}
\title{Simulate causal SNPs}
\usage{
simulate_causal_snps(net, ngenes = 20, pcausal = 1)
}
\arguments{
\item{net}{An igraph gene-interaction (GI) network that connects the SNPs.}

\item{ngenes}{Number of causal genes.}

\item{pcausal}{Number between 0 and 1, proportion of the SNPs in causal genes
that are causal themselves.}
}
\value{
A vector with the ids of the simulated causal SNPs.
}
\description{
Selects randomly interconnected genes as causal, then selects a
proportion of them as causal.
}
\examples{
gi <- get_GI_network(minigwas, snpMapping = minisnpMapping, ppi = minippi)
simulate_causal_snps(gi, ngenes=2)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/legacy.R
\name{get_snp_modules}
\alias{get_snp_modules}
\title{Return groups of interconnected SNPs.}
\usage{
get_snp_modules(gwas, net)
}
\arguments{
\item{gwas}{A SnpMatrix object with the GWAS information.}

\item{net}{An igraph network that connects the SNPs.}
}
\value{
A list with the modules of selected SNPs.
}
\description{
Find modules composed by interconnected SNPs.
}
\examples{
\dontrun{
gi <- get_GI_network(minigwas, snpMapping = minisnpMapping, ppi = minippi)
cones <- search_cones(minigwas, gi)
martini:::get_snp_modules(cones, gi)
}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simulation.R
\name{calculateG}
\alias{calculateG}
\title{Calculate the genetic component of the phenotype}
\usage{
calculateG(effectSize, X, model)
}
\arguments{
\item{effectSize}{A vector with the effect size of each SNP.}

\item{X}{Genotypes in a numeric matrix, where each row is a sample and each
column a SNP.}

\item{model}{Genetic model to assume.}
}
\value{
A vector with the genetic component of each sample.
}
\description{
Calculates the genetic component of the phenotype from a
genotype.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{connect_biomart}
\alias{connect_biomart}
\title{Open a biomaRt connection}
\usage{
connect_biomart(organism)
}
\arguments{
\item{organism}{String containing the ensembl species name (e.g. hsapiens 
for human)}
}
\description{
Opens a biomaRt connection for the relevant species.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/viz.R
\name{group_snps}
\alias{group_snps}
\title{Groups nearby SNPs}
\usage{
group_snps(bed, chr_col, pos_col, threshold)
}
\arguments{
\item{bed}{data.frame containing at least two properties (chromosome and 
position) of a set of SNPs.}

\item{chr_col}{Name of the column containing the SNP chromosome.}

\item{pos_col}{Name of the column containing the SNP position.}

\item{threshold}{Maximum distance to group two SNPs group.}
}
\value{
A data.frame in bed format, with the same dimensions as the original,
but with the groups.
}
\description{
Groups SNPs closer than a specifiec threshold of distance.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simulation.R
\name{simulate_phenotype}
\alias{simulate_phenotype}
\title{Simulate phenotype}
\usage{
simulate_phenotype(
  gwas,
  snps,
  h2,
  model = "additive",
  effectSize = rnorm(length(snps)),
  qualitative = FALSE,
  ncases,
  ncontrols,
  prevalence
)
}
\arguments{
\item{gwas}{A SnpMatrix object with the GWAS information.}

\item{snps}{Character vector with the SNP ids of the causal SNPs. Must match
SNPs in gwas[["map"]][["snp.name"]].}

\item{h2}{Heritability of the phenotype (between 0 and 1).}

\item{model}{String specifying the genetic model under the phenotype.
Accepted values: "additive".}

\item{effectSize}{Numeric vector with the same lenght as the number of causal
SNPs. It indicates the effect size of each of the SNPs; if absent, they are
sampled fron a normal distribution.}

\item{qualitative}{Bool indicating if the phenotype is qualitative or not
(quantitative).}

\item{ncases}{Integer specifying the number of cases to simulate in a
qualitative phenotype. Required if qualitative = TRUE.}

\item{ncontrols}{Integer specifying the number of controls to simulate in a
qualitative phenotype. Required if qualitative = TRUE.}

\item{prevalence}{Value between 0 and 1 specifying the population prevalence
of the disease. Note that ncases cannot be greater than 
prevalence * number of samples. Required if qualitative = TRUE.}
}
\value{
A copy of the GWAS experiment with the new phenotypes in
\code{gwas[["fam"]][["affected"]]}.
}
\description{
Simulates a phenotype from a GWAS experiment and a specified set
of causal SNPs. If the data is qualitative, only controls are used.
}
\examples{
gi <- get_GI_network(minigwas, snpMapping = minisnpMapping, ppi = minippi)
causal <- simulate_causal_snps(gi, ngenes = 2)
simulate_phenotype(minigwas, causal, h2 = 1)
}
\references{
Inspired from GCTA simulation tool:
\url{http://cnsgenomics.com/software/gcta/Simu.html}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scones.R
\name{get_grid}
\alias{get_grid}
\title{Parse \code{scones.cv} settings}
\usage{
get_grid(c = numeric(), etas = numeric(), lambdas = numeric())
}
\arguments{
\item{c}{Numeric vector with the association scores of the SNPs. Specify it 
to automatically an appropriate range of etas and lambas.}

\item{etas}{Numeric vector with the etas to explore in the grid search. If 
ommited, it's automatically created based on the association
scores.}

\item{lambdas}{Numeric vector with the lambdas to explore in the grid search.
If ommited, it's automatically created based on the association scores.}
}
\value{
A list of \code{scones.cv} settings.
}
\description{
Creates a list composed by all \code{scones.cv} settings, with 
the values provided by the user, or the default ones if none is provided.
}
\examples{
martini:::get_grid(etas = c(1,2,3), lambdas = c(4,5,6))
martini:::get_grid(c = c(1,10,100))
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/db.R
\name{mget_gxg_string}
\alias{mget_gxg_string}
\title{Memoised version of get_gxg_stringdb}
\usage{
mget_gxg_string(organism = 9606)
}
\arguments{
\item{organism}{Tax ID of the studied organism. The default is 9606 (human).}
}
\value{
A data.frame with two columns with pairs of interacting proteins.
}
\description{
Get all protein-protein interactions for an organism from
STRING. It uses a score cut-off of 400.
}
\examples{
# download frog interactions
\dontrun{martini:::get_gxg_string(8364)}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scones.R
\name{snp_test}
\alias{snp_test}
\title{Calculate genotype-phhenotype associations}
\usage{
snp_test(gwas, covars, score, family, link)
}
\arguments{
\item{gwas}{A SnpMatrix object with the GWAS information.}

\item{covars}{A data frame with the covariates. It must contain a column 
'sample' containing the sample IDs, and an additional columns for each 
covariate.}

\item{score}{Association score to measure association between genotype and 
phenotype. Possible values: chi2 (default), glm.}

\item{family}{A string defining the generalized linear model family. This 
should match one of "binomial", "poisson", "gaussian" or "gamma". See
\link[snpStats]{snp.rhs.tests} for details.}

\item{link}{A string defining the link function for the GLM. This should
match one of "logit", "log", "identity" or "inverse". See 
\link[snpStats]{snp.rhs.tests} for details.}
}
\value{
A named vector with the association scores.
}
\description{
Calculate the association between genotypes and a phenotype,
adjusting by covariates.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/networks.R
\name{get_GS_network}
\alias{get_GS_network}
\title{Get genomic sequence network}
\usage{
get_GS_network(gwas)
}
\arguments{
\item{gwas}{A SnpMatrix object with the GWAS information.}
}
\value{
An igraph network of the GS network of the SNPs.
}
\description{
Creates a network of SNPs where each SNP is connected to its 
adjacent SNPs in the genome sequence. Corresponds to the genomic sequence 
(GS) network described by Azencott et al.
}
\examples{
get_GS_network(minigwas)
}
\references{
Azencott, C. A., Grimm, D., Sugiyama, M., Kawahara, Y., &
Borgwardt, K. M. (2013). Efficient network-guided multi-locus association
mapping with graph cuts. Bioinformatics, 29(13), 171-179.
\url{https://doi.org/10.1093/bioinformatics/btt238}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/nongwas.R
\name{scones.cv_}
\alias{scones.cv_}
\title{Find connected explanatory features}
\usage{
scones.cv_(X, y, featnames, net)
}
\arguments{
\item{X}{n x d design matrix}

\item{y}{Vector of length n with the outcomes}

\item{featnames}{Vector of length d with the feature names}

\item{net}{An igraph network that connects the SNPs.}
}
\value{
A copy of the \code{SnpMatrix$map} \code{data.frame}, with the 
following additions:
\itemize{
\item{c: contains the univariate association score for every single SNP.}
\item{selected: logical vector indicating if the SNP was selected by SConES 
or not.}
\item{module: integer with the number of the module the SNP belongs to.}
}
}
\description{
Finds the features maximally associated with a phenotype while 
being connected in an underlying network. Select the hyperparameters by
cross-validation.
}
\examples{
X <- as(minigwas[['genotypes']], 'numeric')
X <- X + matrix(rnorm(2500, sd = 0.1), nrow(X), ncol(X))
gi <- get_GI_network(minigwas, snpMapping = minisnpMapping, ppi = minippi)
scones.cv_(X, minigwas[['fam']]$affected, minigwas[['map']]$snp, gi)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{sanitize_snpMapping}
\alias{sanitize_snpMapping}
\title{Check snpMapping}
\usage{
sanitize_snpMapping(snpMapping, col_genes)
}
\arguments{
\item{snpMapping}{data.frame containing the correspondence between SNPs and
genes.}

\item{col_genes}{Length 2 character vector containing the colnames containing
the SNP and the gene ids, respectively.}
}
\description{
Check that snpMapping is a proper data.frame.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/legacy.R
\name{search_cones}
\alias{search_cones}
\title{Find connected explanatory SNPs.}
\usage{
search_cones(
  gwas,
  net,
  encoding = "additive",
  sigmod = FALSE,
  covars = data.frame(),
  associationScore = c("chi2", "glm"),
  modelScore = c("stability", "bic", "aic", "aicc", "global_clustering",
    "local_clustering"),
  etas = numeric(),
  lambdas = numeric()
)
}
\arguments{
\item{gwas}{A SnpMatrix object with the GWAS information.}

\item{net}{An igraph network that connects the SNPs.}

\item{encoding}{SNP encoding (unused argument).}

\item{sigmod}{Boolean. If TRUE, use the Sigmod variant of SConES, meant to 
prioritize tightly connected clusters of SNPs.}

\item{covars}{A data frame with the covariates. It must contain a column 
'sample' containing the sample IDs, and an additional columns for each 
covariate.}

\item{associationScore}{Association score to measure association between 
genotype and phenotype.}

\item{modelScore}{String with the function to measure the quality of a split.}

\item{etas}{Numeric vector with the etas to explore in the grid search. If 
ommited, it's automatically created based on the association
scores.}

\item{lambdas}{Numeric vector with the lambdas to explore in the grid search.
If ommited, it's automatically created based on the association scores.}
}
\value{
A copy of the \code{SnpMatrix$map} \code{data.frame}, with the 
following additions:
\itemize{
\item{c: contains the univariate association score for every single SNP.}
\item{selected: logical vector indicating if the SNP was selected by SConES 
or not.}
\item{module: integer with the number of the module the SNP belongs to.}
}
}
\description{
Finds the SNPs maximally associated with a phenotype while being
 connected in an underlying network (Azencott et al., 2013).
}
\examples{
\dontrun{gi <- get_GI_network(minigwas, snpMapping = minisnpMapping, ppi = minippi)
search_cones(minigwas, gi)
search_cones(minigwas, gi, encoding = "recessive")
search_cones(minigwas, gi, associationScore = "skat")}
}
\references{
Azencott, C. A., Grimm, D., Sugiyama, M., Kawahara, Y., & 
Borgwardt, K. M. (2013). Efficient network-guided multi-locus 
association mapping with graph cuts. Bioinformatics, 29(13), 171-179. 
\url{https://doi.org/10.1093/bioinformatics/btt238}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/nongwas.R
\name{sigmod_}
\alias{sigmod_}
\title{Find connected explanatory features}
\usage{
sigmod_(X, y, featnames, net, eta, lambda)
}
\arguments{
\item{X}{n x d design matrix}

\item{y}{Vector of length n with the outcomes}

\item{featnames}{Vector of length d with the feature names}

\item{net}{An igraph network that connects the SNPs.}

\item{eta}{Value of the eta parameter.}

\item{lambda}{Value of the lambda parameter.}
}
\value{
A copy of the \code{SnpMatrix$map} \code{data.frame}, with the 
following additions:
\itemize{
\item{c: contains the univariate association score for every single SNP.}
\item{selected: logical vector indicating if the SNP was selected by SConES 
or not.}
\item{module: integer with the number of the module the SNP belongs to.}
}
}
\description{
Finds the features maximally associated with a phenotype while 
being connected in an underlying network.
}
\examples{
X <- as(minigwas[['genotypes']], 'numeric')
X <- X + matrix(rnorm(2500, sd = 0.1), nrow(X), ncol(X))
gi <- get_GI_network(minigwas, snpMapping = minisnpMapping, ppi = minippi)
sigmod_(X, minigwas[['fam']]$affected, minigwas[['map']]$snp, gi, 10, 1)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/datasets.R
\docType{data}
\name{minisnpMapping}
\alias{minisnpMapping}
\title{Genes for the minigwas dataset.}
\description{
data.frame that maps SNPs from minigwas to their gene.
}
\examples{
data(minisnpMapping)

head(minisnpMapping)
}
